﻿#Область ПрограммныйИнтерфейс

Функция ПолучитьДанныеБазыИсточника(Настройки, Параметры) Экспорт
	
	Если Настройки.ВариантПодключения = Перечисления.кс_ВариантыПодключенияБазы.COMСоединениеСерверное 
		ИЛИ Настройки.ВариантПодключения = Перечисления.кс_ВариантыПодключенияБазы.COMСоединениеФайловое Тогда
		
		СтруктураТаблиц = ПолучитьСтруктуруПоCOMСоединению(Настройки, Параметры);
		
	Иначе
		
		ПутьКФАйлу = Настройки.ПутьКФайлу;
		СтруктураТаблиц = СтруктураТаблицИзФайла(ПутьКФайлу, Параметры);
		
	КонецЕсли;
	
	Возврат СтруктураТаблиц;
	
КонецФункции

#КонецОбласти

#Область СлужебныйПрограммныйИнтерфейс

Функция ПолучитьXMLДанные(Параметры = Неопределено, ВключитьСсылочныеКолонки = Ложь) Экспорт
	
	СтруктураТаблицКСравнению = СтруктураТаблиц(Параметры, ВключитьСсылочныеКолонки);
	СтрокаXML = ФормированиеXMLСтроки(СтруктураТаблицКСравнению);
	
	Возврат СтрокаXML;
	
КонецФункции

Функция СтруктураТаблицИзФайла(ПутьКФайлу, Параметры = Ложь) Экспорт
	
	СтрокаXML = ПолучитьXMLИзФайла(ПутьКФайлу);
	
	Если СтрокаXML = Неопределено Тогда
		
		ОбщегоНазначения.СообщитьПользователю("Не удалось подключиться к файлу "+ПутьКФайлу);
		Возврат Неопределено;
		
	КонецЕсли;
	
	СтруктураТаблиц = ЧтениеСтруктурыИзXML(СтрокаXML);
	
	СтруктураТаблицСОтбором = ОтобратьТаблицы(СтруктураТаблиц, Параметры);
	
	Возврат СтруктураТаблицСОтбором;
	
КонецФункции

Функция ПодключитьсяКБазе(Настройки) Экспорт
	
	Если Настройки.ВариантПодключения = Перечисления.кс_ВариантыПодключенияБазы.COMСоединениеСерверное Тогда
		Сервер = Настройки.Сервер;
		БазаДанных = Настройки.БазаДанных;
		Пользователь = Настройки.Пользователь;
		Пароль = Настройки.Пароль;
		
		ПараметрыПодключенияИБ = "srvr='" + СокрЛП(Сервер)
		+ "'; ref='" + СокрЛП(БазаДанных)
		+ "'; usr='" + СокрЛП(Пользователь)
		+ "'; pwd='" + СокрЛП(Пароль) + "';";
	Иначе
		ПутьКФайловойБазе = Настройки.ПутьКФайловойБазе;
		ПараметрыПодключенияИБ = "File=""" + СокрЛП(ПутьКФайловойБазе) + """";
	КонецЕсли;
	
	
	
	Попытка
		V83COMCon= Новый COMОбъект("V83.COMConnector");
		Возврат V83COMCon.Connect(ПараметрыПодключенияИБ);
	Исключение
		Сообщить(ОписаниеОшибки());
		Возврат Неопределено;
	КонецПопытки;
	
КонецФункции

Функция ИсточникТекущейБазы() Экспорт
	
	Возврат -1;
	
КонецФункции

Функция ИсточникБазыИсточника() Экспорт
	
	Возврат 1;
	
КонецФункции

Функция ПолучитьXMLИзФайла(ПутьКФайлу) Экспорт
	
	
	Попытка
		
		Файл = Новый ЧтениеТекста(ПутьКФайлу);
		ФайлСтрокой = Файл.Прочитать();
		Файл.Закрыть();
		
	Исключение
		
		Возврат Неопределено;
		
	КонецПопытки;
	
	Возврат ФайлСтрокой;
	
КонецФункции

Функция СуффиксТекущейБазы() Экспорт
	
	Возврат "ERP";
	
КонецФункции

Функция СуффиксБазыИсточника() Экспорт
	
	Возврат "УПП";
	
КонецФункции

Функция СтруктураТаблиц(Параметры, ВключитьСсылочныеКолонки) Экспорт
	
	СтруктураТаблиц = Новый Структура;
	
	Если Параметры.Свойство("СписокТаблиц") Тогда
		СписокТаблицКДобавлению = Параметры.СписокТаблиц;
	КонецЕсли;
	ИспользоватьОтборПоТаблицам = Параметры.ИспользованиеСпискаТаблиц;
	
	Если ИспользоватьОтборПоТаблицам = Ложь Или СписокТаблицКДобавлению.НайтиПоЗначению("Контрагенты") <> Неопределено Тогда
		СтруктураТаблиц.Вставить("Контрагенты", ПолучитьТаблицуКонтрагентов(Параметры, ВключитьСсылочныеКолонки));
	КонецЕсли;
	Если ИспользоватьОтборПоТаблицам = Ложь Или СписокТаблицКДобавлению.НайтиПоЗначению("ДоговорыКонтрагентов") <> Неопределено Тогда
		СтруктураТаблиц.Вставить("ДоговорыКонтрагентов", ПолучитьТаблицуДоговорыКонтрагентов(Параметры, ВключитьСсылочныеКолонки));
	КонецЕсли;
	Если ИспользоватьОтборПоТаблицам = Ложь Или СписокТаблицКДобавлению.НайтиПоЗначению("Склады") <> Неопределено Тогда
		СтруктураТаблиц.Вставить("Склады", ПолучитьТаблицуСклады(Параметры, ВключитьСсылочныеКолонки));
	КонецЕсли;
	Если ИспользоватьОтборПоТаблицам = Ложь Или СписокТаблицКДобавлению.НайтиПоЗначению("Номенклатура") <> Неопределено Тогда
		СтруктураТаблиц.Вставить("Номенклатура", ПолучитьТаблицуНоменклатура(Параметры, ВключитьСсылочныеКолонки));
	КонецЕсли;
	Если ИспользоватьОтборПоТаблицам = Ложь Или СписокТаблицКДобавлению.НайтиПоЗначению("ФизическиеЛица") <> Неопределено Тогда
		СтруктураТаблиц.Вставить("ФизическиеЛица", ПолучитьТаблицуФизическиеЛица(Параметры, ВключитьСсылочныеКолонки));
	КонецЕсли;
	Если ИспользоватьОтборПоТаблицам = Ложь Или СписокТаблицКДобавлению.НайтиПоЗначению("ГруппаАналитическогоУчета") <> Неопределено Тогда
		СтруктураТаблиц.Вставить("ГруппаАналитическогоУчета", ПолучитьТаблицуГруппаАналитическогоУчета(Параметры, ВключитьСсылочныеКолонки));
	КонецЕсли;
	Если ИспользоватьОтборПоТаблицам = Ложь Или СписокТаблицКДобавлению.НайтиПоЗначению("ПоступлениеДенежныхДокументов") <> Неопределено Тогда
		СтруктураТаблиц.Вставить("ПоступлениеДенежныхДокументов", ПолучитьТаблицуПоступлениеДенежныхДокументов(Параметры, ВключитьСсылочныеКолонки));
	КонецЕсли;
	Если ИспользоватьОтборПоТаблицам = Ложь Или СписокТаблицКДобавлению.НайтиПоЗначению("ПеремещениеТоваров") <> Неопределено Тогда
		СтруктураТаблиц.Вставить("ПеремещениеТоваров", ПолучитьТаблицуПеремещениеТоваров(Параметры, ВключитьСсылочныеКолонки));
	КонецЕсли;
	Если ИспользоватьОтборПоТаблицам = Ложь Или СписокТаблицКДобавлению.НайтиПоЗначению("СписаниеТоваров") <> Неопределено Тогда
		СтруктураТаблиц.Вставить("СписаниеТоваров", ПолучитьТаблицуСписаниеНедостачТоваров(Параметры, ВключитьСсылочныеКолонки));
	КонецЕсли;
	Если ИспользоватьОтборПоТаблицам = Ложь Или СписокТаблицКДобавлению.НайтиПоЗначению("ОприходованиеМатериаловИзПроизводства") <> Неопределено Тогда
		СтруктураТаблиц.Вставить("ОприходованиеМатериаловИзПроизводства", ПолучитьТаблицуВозвратМатериаловИзКладовой(Параметры, ВключитьСсылочныеКолонки));
	КонецЕсли;
	Если ИспользоватьОтборПоТаблицам = Ложь Или СписокТаблицКДобавлению.НайтиПоЗначению("ДенежныеДокументы") <> Неопределено Тогда
		СтруктураТаблиц.Вставить("ДенежныеДокументы", ПолучитьТаблицуДенежныеДокументы(Параметры, ВключитьСсылочныеКолонки));
	КонецЕсли;
	Если ИспользоватьОтборПоТаблицам = Ложь Или СписокТаблицКДобавлению.НайтиПоЗначению("КорректировкаРеализации") <> Неопределено Тогда
		СтруктураТаблиц.Вставить("КорректировкаРеализации", ПолучитьТаблицуКорректировкаРеализации(Параметры, ВключитьСсылочныеКолонки));
	КонецЕсли;
	Если ИспользоватьОтборПоТаблицам = Ложь Или СписокТаблицКДобавлению.НайтиПоЗначению("АвансовыйОтчет") <> Неопределено Тогда
		СтруктураТаблиц.Вставить("АвансовыйОтчет", ПолучитьТаблицуАвансовыйОтчет(Параметры, ВключитьСсылочныеКолонки));
	КонецЕсли;
	Если ИспользоватьОтборПоТаблицам = Ложь Или СписокТаблицКДобавлению.НайтиПоЗначению("ПоступлениеДенежныхСредств") <> Неопределено Тогда
		СтруктураТаблиц.Вставить("ПоступлениеДенежныхСредств", ПолучитьТаблицуПоступлениеБезналичныхДенежныхСредств(Параметры, ВключитьСсылочныеКолонки));
	КонецЕсли;
	Если ИспользоватьОтборПоТаблицам = Ложь Или СписокТаблицКДобавлению.НайтиПоЗначению("СписаниеДенежныхСредств") <> Неопределено Тогда
		СтруктураТаблиц.Вставить("СписаниеДенежныхСредств", ПолучитьТаблицуСписаниеБезналичныхДенежныхСредств(Параметры, ВключитьСсылочныеКолонки));
	КонецЕсли;
	Если ИспользоватьОтборПоТаблицам = Ложь Или СписокТаблицКДобавлению.НайтиПоЗначению("РесурсныеСпецификации") <> Неопределено Тогда
		СтруктураТаблиц.Вставить("РесурсныеСпецификации", ПолучитьТаблицуРесурсныеСпецификации(Параметры, ВключитьСсылочныеКолонки));
	КонецЕсли;
	Если ИспользоватьОтборПоТаблицам = Ложь Или СписокТаблицКДобавлению.НайтиПоЗначению("СтатьиДвиженияДенежныхСредств") <> Неопределено Тогда
		СтруктураТаблиц.Вставить("СтатьиДвиженияДенежныхСредств", ПолучитьТаблицуСтатьиДвиженияДенежныхСредств(Параметры, ВключитьСсылочныеКолонки));
	КонецЕсли;
	Если ИспользоватьОтборПоТаблицам = Ложь Или СписокТаблицКДобавлению.НайтиПоЗначению("Подразделения") <> Неопределено Тогда
		СтруктураТаблиц.Вставить("Подразделения", ПолучитьТаблицуСтруктураПредприятия(Параметры, ВключитьСсылочныеКолонки));
	КонецЕсли;
	Если ИспользоватьОтборПоТаблицам = Ложь Или СписокТаблицКДобавлению.НайтиПоЗначению("ПодразделенияОрганизаций") <> Неопределено Тогда
		СтруктураТаблиц.Вставить("ПодразделенияОрганизаций", ПолучитьТаблицуСтруктураПредприятия(Параметры, ВключитьСсылочныеКолонки));
	КонецЕсли;
	Если ИспользоватьОтборПоТаблицам = Ложь Или СписокТаблицКДобавлению.НайтиПоЗначению("СтатьиРасходов") <> Неопределено Тогда
		СтруктураТаблиц.Вставить("СтатьиРасходов", ПолучитьТаблицуСтатьиРасходов(Параметры, ВключитьСсылочныеКолонки));
	КонецЕсли;
	Если ИспользоватьОтборПоТаблицам = Ложь Или СписокТаблицКДобавлению.НайтиПоЗначению("ПрочиеДоходыИРасходы") <> Неопределено Тогда
		СтруктураТаблиц.Вставить("ПрочиеДоходыИРасходы", ПолучитьТаблицуПрочиеДоходыИРасходы(Параметры, ВключитьСсылочныеКолонки));
	КонецЕсли;
	Если ИспользоватьОтборПоТаблицам = Ложь Или СписокТаблицКДобавлению.НайтиПоЗначению("БанковскиеСчетаКонтрагентов") <> Неопределено Тогда
		СтруктураТаблиц.Вставить("БанковскиеСчетаКонтрагентов", ПолучитьТаблицуБанковскиеСчетаКонтрагентов(Параметры, ВключитьСсылочныеКолонки));
	КонецЕсли;
	Если ИспользоватьОтборПоТаблицам = Ложь Или СписокТаблицКДобавлению.НайтиПоЗначению("ПередачаМатериаловВЭксплуатацию") <> Неопределено Тогда
		СтруктураТаблиц.Вставить("ПередачаМатериаловВЭксплуатацию", ПолучитьТаблицуВнутреннееПотреблениеТоваровПередачаВЭксплуатацию(Параметры, ВключитьСсылочныеКолонки));
	КонецЕсли;
	Если ИспользоватьОтборПоТаблицам = Ложь Или СписокТаблицКДобавлению.НайтиПоЗначению("ПриобретениеТоваровУслуг") <> Неопределено Тогда
		СтруктураТаблиц.Вставить("ПриобретениеТоваровУслуг", ПолучитьТаблицуПриобретениеТоваровУслуг(Параметры, ВключитьСсылочныеКолонки));
	КонецЕсли;
	Если ИспользоватьОтборПоТаблицам = Ложь Или СписокТаблицКДобавлению.НайтиПоЗначению("ОприходованиеТоваров") <> Неопределено Тогда
		СтруктураТаблиц.Вставить("ОприходованиеТоваров", ПолучитьТаблицуОприходованиеИзлишковТоваров(Параметры, ВключитьСсылочныеКолонки));
	КонецЕсли;
	Если ИспользоватьОтборПоТаблицам = Ложь Или СписокТаблицКДобавлению.НайтиПоЗначению("РеализацияТоваровУслуг") <> Неопределено Тогда
		СтруктураТаблиц.Вставить("РеализацияТоваровУслуг", ПолучитьТаблицуРеализацияТоваровУслуг(Параметры, ВключитьСсылочныеКолонки));
	КонецЕсли;
	Если ИспользоватьОтборПоТаблицам = Ложь Или СписокТаблицКДобавлению.НайтиПоЗначению("СчетФактураВыданный") <> Неопределено Тогда
		СтруктураТаблиц.Вставить("СчетФактураВыданный", ПолучитьТаблицуСчетФактураВыданный(Параметры, ВключитьСсылочныеКолонки));
	КонецЕсли;
	Если ИспользоватьОтборПоТаблицам = Ложь Или СписокТаблицКДобавлению.НайтиПоЗначению("ВыдачаДенежныхДокументовПодотчетнику") <> Неопределено Тогда
		СтруктураТаблиц.Вставить("ВыдачаДенежныхДокументовПодотчетнику", ПолучитьТаблицуВыбытиеДенежныхДокументовПодотчетнику(Параметры, ВключитьСсылочныеКолонки));
	КонецЕсли;
	Если ИспользоватьОтборПоТаблицам = Ложь Или СписокТаблицКДобавлению.НайтиПоЗначению("ВозвратДенежныхДокументовПоставщику") <> Неопределено Тогда
		СтруктураТаблиц.Вставить("ВозвратДенежныхДокументовПоставщику", ПолучитьТаблицуВозвратДенежныхДокументовПоставщику(Параметры, ВключитьСсылочныеКолонки));
	КонецЕсли;
	Если ИспользоватьОтборПоТаблицам = Ложь Или СписокТаблицКДобавлению.НайтиПоЗначению("ВозвратМатериаловИзЭксплуатации") <> Неопределено Тогда
		СтруктураТаблиц.Вставить("ВозвратМатериаловИзЭксплуатации", ПолучитьТаблицуПрочееОприходованиеТоваровВозвратИзЭксплуатации(Параметры, ВключитьСсылочныеКолонки));
	КонецЕсли;
	Если ИспользоватьОтборПоТаблицам = Ложь Или СписокТаблицКДобавлению.НайтиПоЗначению("ВнутреннееПотреблениеТоваров") <> Неопределено Тогда
		СтруктураТаблиц.Вставить("ВнутреннееПотреблениеТоваров", ПолучитьТаблицуВнутреннееПотреблениеТоваровСписаниеТоваровПоТребованию(Параметры, ВключитьСсылочныеКолонки));
	КонецЕсли;
	Если ИспользоватьОтборПоТаблицам = Ложь Или СписокТаблицКДобавлению.НайтиПоЗначению("ДвижениеПродукцииИМатериалов") <> Неопределено Тогда
		СтруктураТаблиц.Вставить("ДвижениеПродукцииИМатериалов", ПолучитьТаблицуДвижениеПродукцииИМатериалов(Параметры, ВключитьСсылочныеКолонки));
	КонецЕсли;
	Если ИспользоватьОтборПоТаблицам = Ложь Или СписокТаблицКДобавлению.НайтиПоЗначению("ОтчетПроизводстваЗаСмену") <> Неопределено Тогда
		СтруктураТаблиц.Вставить("ОтчетПроизводстваЗаСмену", ПолучитьТаблицуПроизводствоБезЗаказа(Параметры, ВключитьСсылочныеКолонки));
	КонецЕсли;
	Если ИспользоватьОтборПоТаблицам = Ложь Или СписокТаблицКДобавлению.НайтиПоЗначению("ПоступлениеТоваровУслуг") <> Неопределено Тогда
		СтруктураТаблиц.Вставить("ПоступлениеТоваровУслуг", ПолучитьТаблицуПриобретениеТоваровУслугТовары(Параметры, ВключитьСсылочныеКолонки));
	КонецЕсли;
	Если ИспользоватьОтборПоТаблицам = Ложь Или СписокТаблицКДобавлению.НайтиПоЗначению("ПриобретениеУслугПрочихАктивов") <> Неопределено Тогда
		СтруктураТаблиц.Вставить("ПриобретениеУслугПрочихАктивов", ПолучитьТаблицуПриобретениеУслугПрочихАктивов(Параметры, ВключитьСсылочныеКолонки));
	КонецЕсли;
	Если ИспользоватьОтборПоТаблицам = Ложь Или СписокТаблицКДобавлению.НайтиПоЗначению("ПринятиеКУчетуОС") <> Неопределено Тогда
		СтруктураТаблиц.Вставить("ПринятиеКУчетуОС", ПолучитьТаблицуВнутреннееПотреблениеТоваровПринятиеОС(Параметры, ВключитьСсылочныеКолонки));
	КонецЕсли;
	
	Возврат СтруктураТаблиц;
	
КонецФункции

#КонецОбласти

#Область СлужебныеПроцедурыИФункции

Функция ФормированиеXMLСтроки(СтруктураТаблицКСравнению)
	
	ЗаписьXML = Новый ЗаписьXML;
	ЗаписьXML.УстановитьСтроку();
	
	ОбъектXDTO = СериализаторXDTO.ЗаписатьXDTO(СтруктураТаблицКСравнению);
	ФабрикаXDTO.ЗаписатьXML(ЗаписьXML, ОбъектXDTO);
	
	Возврат ЗаписьXML.Закрыть();
	
КонецФункции

Функция ЧтениеСтруктурыИзXML(XMLСтрока)
	
	ЧтениеXML = Новый ЧтениеXML;
	ЧтениеXML.УстановитьСтроку(XMLСтрока);
	
	ТипОбъектаXDTO = ФабрикаXDTO.Тип("http://v8.1c.ru/8.1/data/core","Structure");
	
	ОбъектXDTO = ФабрикаXDTO.ПрочитатьXML(ЧтениеXML,ТипОбъектаXDTO); 
	ОбъектXDTO.Проверить();
	
	ЧтениеXML.Закрыть();
	
	СтруктураТаблиц = СериализаторXDTO.ПрочитатьXDTO(ОбъектXDTO);
	
	Возврат СтруктураТаблиц;
	
КонецФункции

Функция ОтобратьТаблицы(СтруктураТаблиц, Параметры)
	
	СписокТаблицКОтбору = Параметры.СписокТаблиц;
	
	
	Для Каждого Таблица Из СтруктураТаблиц Цикл
		Если Параметры.ИспользованиеСпискаТаблиц = Истина
			И СписокТаблицКОтбору.НайтиПоЗначению(Таблица.Ключ) = Неопределено Тогда
			
			СтруктураТаблиц.Удалить(Таблица.Ключ);
		Иначе
			Если Таблица.Значение.Колонки.Найти("ДатаДляОтбора") <> Неопределено Тогда
				УдалитьДокументыВнеПериода(Таблица.Значение, Параметры);
			КонецЕсли;
		КонецЕсли;
	КонецЦикла;
	
	Возврат СтруктураТаблиц;
	
КонецФункции

Процедура УдалитьДокументыВнеПериода(Таблица, Параметры)
	
	НачалоПериода = Параметры.Период.ДатаНачала;
	КонецПериода = Параметры.Период.ДатаОкончания;
	
	МассивСтрокКУдалению = Новый Массив;
	
	Для Каждого Строка Из Таблица Цикл
		Если Строка.ДатаДляОтбора < НачалоПериода Или Строка.ДатаДляОтбора > КонецПериода Тогда
			МассивСтрокКУдалению.Добавить(Строка);
		КонецЕсли;
	КонецЦикла;
	
	Для Каждого СтрокаКУдалению Из МассивСтрокКУдалению Цикл
		Таблица.Удалить(СтрокаКУдалению);
	КонецЦикла;
	
КонецПроцедуры

Функция ПолучитьСтруктуруПоCOMСоединению(Настройки, Параметры)
	Попытка
		Соединение = ПодключитьсяКБазе(Настройки);
		XMLСтрока = Соединение.кс_ОбработкаДанныхДляОтчетаСравненияБазДанных.ПолучитьXMLДанные(Параметры);
	Исключение
		ОбщегоНазначения.СообщитьПользователю("Не удалось подключиться к базе "+Настройки.БазаДанных);
		Возврат Неопределено;
	КонецПопытки;
	
	Возврат ЧтениеСтруктурыИзXML(XMLСтрока);
	
КонецФункции


Функция ПолучитьТаблицуДоговорыКонтрагентов(Параметры = Неопределено, ВключитьСсылочныеКолонки = Ложь)
	
	Запрос = Новый Запрос;
	Запрос.Текст = 
	"ВЫБРАТЬ
	|	ДоговорыКонтрагентов.Ссылка КАК Ссылка,
	|	ДоговорыКонтрагентов.Наименование КАК Наименование,
	|	ДоговорыКонтрагентов.Контрагент КАК Контрагент,
	|	ДоговорыКонтрагентов.Контрагент.Наименование КАК КонтрагентНаименование,
	|	ДоговорыКонтрагентов.ВалютаВзаиморасчетов КАК Валюта
	|ИЗ
	|	Справочник.ДоговорыКонтрагентов КАК ДоговорыКонтрагентов
	|УПОРЯДОЧИТЬ ПО Наименование ВОЗР";
	
	Таблица = Запрос.Выполнить().Выгрузить();
	Таблица.Колонки.Добавить("УникальныйИдентификатор", Новый ОписаниеТипов("УникальныйИдентификатор"));
	Таблица.Колонки.Добавить("КонтрагентИдентификатор", Новый ОписаниеТипов("УникальныйИдентификатор"));
	
	Для Каждого Строка Из Таблица Цикл
		
		Строка.УникальныйИдентификатор = Строка.Ссылка.УникальныйИдентификатор();
		Строка.КонтрагентИдентификатор = Строка.Контрагент.УникальныйИдентификатор();
		
	КонецЦикла;
	
	Таблица.Колонки.Удалить("Контрагент");
	                              
	Если Не ВключитьСсылочныеКолонки Тогда
		Таблица.Колонки.Удалить("Ссылка");
	КонецЕсли;
	
	ПреобразоватьСумму(Таблица);
	
	Возврат Таблица;
	
КонецФункции

Функция ПолучитьТаблицуКонтрагентов(Параметры = Неопределено, ВключитьСсылочныеКолонки = Ложь)
	
	Запрос = Новый Запрос;
	Запрос.Текст = 
	"ВЫБРАТЬ
	|	Контрагенты.Ссылка КАК Ссылка,
	|	Контрагенты.Наименование КАК Наименование,
	|	Контрагенты.ИНН КАК ИНН,
	|	Контрагенты.КПП КАК КПП,
	|	Контрагенты.ЮрФизЛицо КАК ЮрФизЛицо
	|ИЗ
	|	Справочник.Контрагенты КАК Контрагенты
	|УПОРЯДОЧИТЬ ПО Наименование ВОЗР";
	
	Таблица = Запрос.Выполнить().Выгрузить();
	Таблица.Колонки.Добавить("УникальныйИдентификатор", Новый ОписаниеТипов("УникальныйИдентификатор"));
	Таблица.Колонки.Добавить("СтроковоеЮрФизЛицо"
	, Новый ОписаниеТипов("Строка, null",,,,Новый КвалификаторыСтроки(1000, ДопустимаяДлина.Переменная)));
		
	Для Каждого Строка Из Таблица Цикл
		
		Строка.УникальныйИдентификатор = Строка.Ссылка.УникальныйИдентификатор();
		Строка.СтроковоеЮрФизЛицо = ПреобразоватьПеречислениеВСтроку(Строка.ЮрФизЛицо);
		
	КонецЦикла;
	
	Таблица.Колонки.Удалить("ЮрФизЛицо");
	
	Если Не ВключитьСсылочныеКолонки Тогда
		Таблица.Колонки.Удалить("Ссылка");
	КонецЕсли;
	
	ПреобразоватьСумму(Таблица);
	
	Возврат Таблица;
	
КонецФункции

Функция ПолучитьТаблицуСклады(Параметры = Неопределено, ВключитьСсылочныеКолонки = Ложь)
	
	Запрос = Новый Запрос;
	Запрос.Текст = 
	"ВЫБРАТЬ
	|	Склады.Ссылка КАК Ссылка,
	|	Склады.Наименование КАК Наименование
	|ИЗ
	|	Справочник.Склады КАК Склады
	|УПОРЯДОЧИТЬ ПО Наименование ВОЗР";
	
	Таблица = Запрос.Выполнить().Выгрузить();
	Таблица.Колонки.Добавить("УникальныйИдентификатор", Новый ОписаниеТипов("УникальныйИдентификатор"));
	
	Для Каждого Строка Из Таблица Цикл
		
		Строка.УникальныйИдентификатор = Строка.Ссылка.УникальныйИдентификатор();
		
	КонецЦикла;
	
	
	Если Не ВключитьСсылочныеКолонки Тогда
		Таблица.Колонки.Удалить("Ссылка");
	КонецЕсли;
	
	Возврат Таблица;
	
КонецФункции

Функция ПолучитьТаблицуНоменклатура(Параметры = Неопределено, ВключитьСсылочныеКолонки = Ложь)
	
	Запрос = Новый Запрос;
	Запрос.Текст = 
	"ВЫБРАТЬ
	|	Номенклатура.Ссылка КАК Ссылка,
	|	Номенклатура.Наименование КАК Наименование,
	|	Номенклатура.СтавкаНДС КАК СтавкаНДС,
	|	Номенклатура.ЕдиницаИзмерения.Наименование КАК ЕдиницаХраненияОстатков
	|ИЗ
	|	Справочник.Номенклатура КАК Номенклатура
	|УПОРЯДОЧИТЬ ПО Наименование ВОЗР";
	
	Таблица = Запрос.Выполнить().Выгрузить();
	Таблица.Колонки.Добавить("УникальныйИдентификатор", Новый ОписаниеТипов("УникальныйИдентификатор"));
	Таблица.Колонки.Добавить("СтроковоеСтавкиНДС"
	, Новый ОписаниеТипов("Строка, null",,,,Новый КвалификаторыСтроки(1000, ДопустимаяДлина.Переменная)));
	
	Для Каждого Строка Из Таблица Цикл
		
		Строка.УникальныйИдентификатор = Строка.Ссылка.УникальныйИдентификатор();
		Строка.СтроковоеСтавкиНДС = ПреобразоватьПеречислениеВСтроку(Строка.СтавкаНДС);
		
	КонецЦикла;
	
	Таблица.Колонки.Удалить("СтавкаНДС");
	
	Если Не ВключитьСсылочныеКолонки Тогда
		Таблица.Колонки.Удалить("Ссылка");
	КонецЕсли;
	
	Возврат Таблица;
	
КонецФункции

Функция ПолучитьТаблицуФизическиеЛица(Параметры = Неопределено, ВключитьСсылочныеКолонки = Ложь)
	
	Запрос = Новый Запрос;
	Запрос.Текст = 
	"ВЫБРАТЬ
	|	ФизическиеЛица.Ссылка КАК Ссылка,
	|	ФизическиеЛица.Наименование КАК Наименование,
	|	ФизическиеЛица.ИНН КАК ИНН
	|ИЗ
	|	Справочник.ФизическиеЛица КАК ФизическиеЛица
	|УПОРЯДОЧИТЬ ПО Наименование ВОЗР";
	
	Таблица = Запрос.Выполнить().Выгрузить();
	Таблица.Колонки.Добавить("УникальныйИдентификатор", Новый ОписаниеТипов("УникальныйИдентификатор"));
	
	Для Каждого Строка Из Таблица Цикл
		
		Строка.УникальныйИдентификатор = Строка.Ссылка.УникальныйИдентификатор();
		
	КонецЦикла;
	
	
	Если Не ВключитьСсылочныеКолонки Тогда
		Таблица.Колонки.Удалить("Ссылка");
	КонецЕсли;
	
	Возврат Таблица;
	
КонецФункции

Функция ПолучитьТаблицуГруппаАналитическогоУчета(Параметры = Неопределено, ВключитьСсылочныеКолонки = Ложь)
	
	Запрос = Новый Запрос;
	Запрос.Текст = 
	"ВЫБРАТЬ
	|	ГруппаАналитическогоУчета.Ссылка КАК Ссылка,
	|	ГруппаАналитическогоУчета.Наименование КАК Наименование
	|ИЗ
	|	Справочник.ГруппыАналитическогоУчетаНоменклатуры КАК ГруппаАналитическогоУчета
	|УПОРЯДОЧИТЬ ПО Наименование ВОЗР";
	
	Таблица = Запрос.Выполнить().Выгрузить();
	Таблица.Колонки.Добавить("УникальныйИдентификатор", Новый ОписаниеТипов("УникальныйИдентификатор"));
	
	Для Каждого Строка Из Таблица Цикл
		
		Строка.УникальныйИдентификатор = Строка.Ссылка.УникальныйИдентификатор();
		
	КонецЦикла;
	
	
	Если Не ВключитьСсылочныеКолонки Тогда
		Таблица.Колонки.Удалить("Ссылка");
	КонецЕсли;
	
	Возврат Таблица;
	
КонецФункции

Функция ПолучитьТаблицуПоступлениеДенежныхДокументов(Параметры = Неопределено, ВключитьСсылочныеКолонки = Ложь)
	
	Построитель = Новый ПостроительЗапроса(
	"ВЫБРАТЬ
	|	ПоступлениеДенежныхДокументов.Ссылка КАК Ссылка,
	|	Представление(ПоступлениеДенежныхДокументов.Ссылка) КАК Представление,
	|	ПоступлениеДенежныхДокументов.Номер КАК Номер,
	|	ПоступлениеДенежныхДокументов.Дата КАК ДатаДляОтбора,
	|	ГОД(ПоступлениеДенежныхДокументов.Дата) КАК Год,
	|	ПоступлениеДенежныхДокументов.Контрагент КАК Контрагент,
	|	ПоступлениеДенежныхДокументов.Контрагент.Наименование КАК КонтрагентНаименование,
	|	ПоступлениеДенежныхДокументов.Договор КАК Договор,
	|	ПоступлениеДенежныхДокументов.Договор.Наименование КАК ДоговорНаименование,
	|	ПоступлениеДенежныхДокументовДенежныеДокументы.Сумма КАК Сумма,
	|	ПоступлениеДенежныхДокументов.ДенежныеДокументы.(ДенежныйДокумент,Сумма,Количество) КАК ДенежныеДокументы
	|ИЗ
	|	Документ.ПоступлениеДенежныхДокументов КАК ПоступлениеДенежныхДокументов
	|		ЛЕВОЕ СОЕДИНЕНИЕ
	|		(ВЫБРАТЬ
	|			ПоступлениеДенежныхДокументовДенежныеДокументы.Ссылка,
	|			СУММА(ПоступлениеДенежныхДокументовДенежныеДокументы.Сумма) КАК Сумма
	|		ИЗ
	|			Документ.ПоступлениеДенежныхДокументов.ДенежныеДокументы
	|				КАК ПоступлениеДенежныхДокументовДенежныеДокументы
	|		СГРУППИРОВАТЬ ПО ПоступлениеДенежныхДокументовДенежныеДокументы.Ссылка) КАК ПоступлениеДенежныхДокументовДенежныеДокументы
	|		ПО
	|			(ПоступлениеДенежныхДокументов.Ссылка = ПоступлениеДенежныхДокументовДенежныеДокументы.Ссылка)
	|{ГДЕ
	|	ПоступлениеДенежныхДокументов.Ссылка.Дата КАК Дата
	|}
	|УПОРЯДОЧИТЬ ПО 
	|	Номер ВОЗР
	|");
	
	Если Параметры <> Неопределено
		И Параметры.Свойство("Период") Тогда 
		ЭлементОтбора = Построитель.Отбор.Добавить("Дата");
		ЭлементОтбора.Использование = Истина;
		ЭлементОтбора.ВидСравнения = ВидСравнения.ИнтервалВключаяГраницы;
		ЭлементОтбора.ЗначениеС = Параметры.Период.ДатаНачала;
		ЭлементОтбора.ЗначениеПо = Параметры.Период.ДатаОкончания;
	КонецЕсли;
	
	Запрос = Построитель.ПолучитьЗапрос();
	
	Таблица = Запрос.Выполнить().Выгрузить();
	Таблица.Колонки.Добавить("УникальныйИдентификатор", Новый ОписаниеТипов("УникальныйИдентификатор"));
	Таблица.Колонки.Добавить("КонтрагентУникальныйИдентификатор", Новый ОписаниеТипов("УникальныйИдентификатор"));
	Таблица.Колонки.Добавить("ДоговорУникальныйИдентификатор", Новый ОписаниеТипов("УникальныйИдентификатор"));
	Таблица.Колонки.Добавить("ДенежныйДокумент"
	, Новый ОписаниеТипов("Строка, null",,,,Новый КвалификаторыСтроки(1500, ДопустимаяДлина.Переменная)));
	Таблица.Колонки.Добавить("ДенежныйДокументКСравнению"
	, Новый ОписаниеТипов("Строка, null",,,,Новый КвалификаторыСтроки(1500, ДопустимаяДлина.Переменная)));
	
	Для Каждого Строка Из Таблица Цикл
		
		Строка.ДенежныеДокументы.Свернуть("ДенежныйДокумент","Сумма,Количество");
		Строка.УникальныйИдентификатор = Строка.Ссылка.УникальныйИдентификатор();
		Строка.КонтрагентУникальныйИдентификатор = Строка.Контрагент.УникальныйИдентификатор();
		Строка.ДоговорУникальныйИдентификатор = Строка.Договор.УникальныйИдентификатор();
		Строка.ДенежныйДокумент = ПолучитьПредставлениеТЧ(Строка.ДенежныеДокументы, "ДенежныйДокумент,Сумма,Количество");
		Строка.ДенежныйДокументКСравнению
		= ПолучитьСтроковыйИдентификаторТЧДляСравнения(Строка.ДенежныеДокументы
			, "ДенежныйДокумент,Сумма,Количество");
		
	КонецЦикла;
	
	Таблица.Колонки.Удалить("ДенежныеДокументы");
	Таблица.Колонки.Удалить("Контрагент");
	Таблица.Колонки.Удалить("Договор");
	
	Если Не ВключитьСсылочныеКолонки Тогда
		
		Таблица.Колонки.Удалить("Ссылка");
		
	КонецЕсли;
	
	ПреобразоватьСумму(Таблица);
	
	Возврат Таблица;
	
КонецФункции

Функция ПолучитьТаблицуПеремещениеТоваров(Параметры = Неопределено, ВключитьСсылочныеКолонки = Ложь)
	
	Построитель = Новый ПостроительЗапроса(
	"ВЫБРАТЬ
	|	ПеремещениеТоваров.Ссылка КАК Ссылка,
	|	Представление(ПеремещениеТоваров.Ссылка) КАК Представление,
	|	ПеремещениеТоваров.Номер КАК Номер,
	|	ГОД(ПеремещениеТоваров.Дата) КАК Год,
	|	ПеремещениеТоваров.Дата КАК ДатаДляОтбора,
	|	ПеремещениеТоваров.СкладОтправитель.Наименование КАК СкладОтправительНаименование,
	|	ПеремещениеТоваров.СкладОтправитель КАК СкладОтправитель,
	|	ПеремещениеТоваров.СкладПолучатель.Наименование КАК СкладПолучательНаименование,
	|	ПеремещениеТоваров.СкладПолучатель КАК СкладПолучатель,
	|	ПеремещениеТоваров.Товары.(Номенклатура, Номенклатура.Наименование, Количество) КАК Товары
	|ИЗ
	|	Документ.ПеремещениеТоваров КАК ПеремещениеТоваров
	|{ГДЕ
	|	Ссылка.Дата КАК Дата
	|}
	|УПОРЯДОЧИТЬ ПО 
	|	Номер ВОЗР
	|");
	
	Если Параметры <> Неопределено
		И Параметры.Свойство("Период") Тогда 
		ЭлементОтбора = Построитель.Отбор.Добавить("Дата");
		ЭлементОтбора.Использование = Истина;
		ЭлементОтбора.ВидСравнения = ВидСравнения.ИнтервалВключаяГраницы;
		ЭлементОтбора.ЗначениеС = Параметры.Период.ДатаНачала;
		ЭлементОтбора.ЗначениеПо = Параметры.Период.ДатаОкончания;
	КонецЕсли;
	
	Запрос = Построитель.ПолучитьЗапрос();
	
	Таблица = Запрос.Выполнить().Выгрузить();
	Таблица.Колонки.Добавить("УникальныйИдентификатор", Новый ОписаниеТипов("УникальныйИдентификатор"));
	Таблица.Колонки.Добавить("УникальныйИдентификаторТовары", Новый ОписаниеТипов("Строка"));
	Таблица.Колонки.Добавить("УникальныйИдентификаторСкладОтправитель", Новый ОписаниеТипов("УникальныйИдентификатор"));
	Таблица.Колонки.Добавить("УникальныйИдентификаторСкладПолучатель", Новый ОписаниеТипов("УникальныйИдентификатор"));
	Таблица.Колонки.Добавить("Состав", Новый ОписаниеТипов("Строка"));
	
	Для Каждого Строка Из Таблица Цикл
		
		Строка.Товары.Свернуть("Номенклатура,НоменклатураНаименование", "Количество");
		Строка.Товары.Сортировать("Номенклатура Возр");
		Строка.УникальныйИдентификатор = Строка.Ссылка.УникальныйИдентификатор();
		Строка.УникальныйИдентификаторСкладОтправитель = Строка.СкладОтправитель.УникальныйИдентификатор();
		Строка.УникальныйИдентификаторСкладПолучатель = Строка.СкладПолучатель.УникальныйИдентификатор();
		Строка.УникальныйИдентификаторТовары = ПолучитьСтроковыйИдентификаторТЧДляСравнения(Строка.Товары, "Номенклатура,Количество");
		Строка.Состав = ПолучитьПредставлениеТЧ(Строка.Товары, "НоменклатураНаименование,Количество");
		
	КонецЦикла;
	
	
	Если Не ВключитьСсылочныеКолонки Тогда
		
		Таблица.Колонки.Удалить("Ссылка");
		
	КонецЕсли;
	
	Таблица.Колонки.Удалить("Товары");
	Таблица.Колонки.Удалить("СкладОтправитель");
	Таблица.Колонки.Удалить("СкладПолучатель");
	
	Возврат Таблица;
	
КонецФункции

Функция ПолучитьТаблицуСписаниеНедостачТоваров(Параметры = Неопределено, ВключитьСсылочныеКолонки = Ложь)
	
	Построитель = Новый ПостроительЗапроса(
	"ВЫБРАТЬ
	|	СписаниеНедостачТоваров.Ссылка КАК Ссылка,
	|	Представление(СписаниеНедостачТоваров.Ссылка) КАК Представление,
	|	СписаниеНедостачТоваров.Номер,
	|	ГОД(СписаниеНедостачТоваров.Дата) КАК Год,
	|	СписаниеНедостачТоваров.Дата КАК ДатаДляОтбора,
	|	СписаниеНедостачТоваров.Склад КАК Склад,
	|	СписаниеНедостачТоваров.Склад.Наименование КАК СкладНаименование,
	|	СписаниеНедостачТоваров.Товары.(Номенклатура, Номенклатура.Наименование, Количество) КАК Товары
	|ИЗ
	|	Документ.СписаниеНедостачТоваров КАК СписаниеНедостачТоваров
	|{ГДЕ
	|	Ссылка.Дата КАК Дата
	|}
	|УПОРЯДОЧИТЬ ПО 
	|	Номер ВОЗР
	|");
	
	Если Параметры <> Неопределено
		И Параметры.Свойство("Период") Тогда 
		ЭлементОтбора = Построитель.Отбор.Добавить("Дата");
		ЭлементОтбора.Использование = Истина;
		ЭлементОтбора.ВидСравнения = ВидСравнения.ИнтервалВключаяГраницы;
		ЭлементОтбора.ЗначениеС = Параметры.Период.ДатаНачала;
		ЭлементОтбора.ЗначениеПо = Параметры.Период.ДатаОкончания;
	КонецЕсли;
	
	Запрос = Построитель.ПолучитьЗапрос();
	
	Таблица = Запрос.Выполнить().Выгрузить();
	Таблица.Колонки.Добавить("УникальныйИдентификатор", Новый ОписаниеТипов("УникальныйИдентификатор"));
	Таблица.Колонки.Добавить("УникальныйИдентификаторНоменклатур", Новый ОписаниеТипов("Строка"));
	Таблица.Колонки.Добавить("Состав", Новый ОписаниеТипов("Строка"));
	Таблица.Колонки.Добавить("УникальныйИдентификаторСклад", Новый ОписаниеТипов("УникальныйИдентификатор"));
	
	Для Каждого Строка Из Таблица Цикл
		
		Строка.Товары.Свернуть("Номенклатура,НоменклатураНаименование", "Количество");
		Строка.Товары.Сортировать("Номенклатура Возр");
		Строка.УникальныйИдентификатор = Строка.Ссылка.УникальныйИдентификатор();
		Строка.УникальныйИдентификаторСклад = Строка.Склад.УникальныйИдентификатор();
		Строка.УникальныйИдентификаторНоменклатур = ПолучитьСтроковыйИдентификаторТЧДляСравнения(Строка.Товары, "Номенклатура, Количество");
		Строка.Состав = ПолучитьПредставлениеТЧ(Строка.Товары, "НоменклатураНаименование,Количество");
		
	КонецЦикла;
	
	
	Если Не ВключитьСсылочныеКолонки Тогда
		
		Таблица.Колонки.Удалить("Ссылка");
		
	КонецЕсли;
	
	Таблица.Колонки.Удалить("Товары");
	Таблица.Колонки.Удалить("Склад");
	
	Возврат Таблица;
	
КонецФункции

Функция ПолучитьТаблицуВозвратМатериаловИзКладовой(Параметры = Неопределено, ВключитьСсылочныеКолонки = Ложь)
	
	Построитель = Новый ПостроительЗапроса(
	"ВЫБРАТЬ
	|	ДвижениеПродукцииИМатериалов.Ссылка КАК Ссылка,
	|	Представление(ДвижениеПродукцииИМатериалов.Ссылка) КАК Представление,
	|	ДвижениеПродукцииИМатериалов.Номер КАК Номер,
	|	ГОД(ДвижениеПродукцииИМатериалов.Дата) КАК Год,
	|	ДвижениеПродукцииИМатериалов.Дата КАК ДатаДляОтбора,
	|	ДвижениеПродукцииИМатериалов.Получатель КАК Склад,
	|	ДвижениеПродукцииИМатериалов.Получатель.Наименование КАК СкладНаименование,
	|	ДвижениеПродукцииИМатериалов.Товары.(Номенклатура, Номенклатура.Наименование
	|		, Количество) КАК Товары
	|ИЗ
	|	Документ.ДвижениеПродукцииИМатериалов КАК ДвижениеПродукцииИМатериалов
	|ГДЕ
	|	ДвижениеПродукцииИМатериалов.ХозяйственнаяОперация
	|		= ЗНАЧЕНИЕ(Перечисление.ХозяйственныеОперации.ВозвратМатериаловИзКладовой)
	|	И ДвижениеПродукцииИМатериалов.ВариантПриемкиТоваров
	|		= ЗНАЧЕНИЕ(Перечисление.ВариантыПриемкиТоваров.РазделенаПоЗаказамИНакладным)
	|{ГДЕ
	|	Ссылка.Дата КАК Дата
	|}
	|УПОРЯДОЧИТЬ ПО 
	|	Номер ВОЗР
	|");
	
	Если Параметры <> Неопределено
		И Параметры.Свойство("Период") Тогда 
		ЭлементОтбора = Построитель.Отбор.Добавить("Дата");
		ЭлементОтбора.Использование = Истина;
		ЭлементОтбора.ВидСравнения = ВидСравнения.ИнтервалВключаяГраницы;
		ЭлементОтбора.ЗначениеС = Параметры.Период.ДатаНачала;
		ЭлементОтбора.ЗначениеПо = Параметры.Период.ДатаОкончания;
	КонецЕсли;
	
	Запрос = Построитель.ПолучитьЗапрос();
	
	Таблица = Запрос.Выполнить().Выгрузить();
	Таблица.Колонки.Добавить("УникальныйИдентификатор", Новый ОписаниеТипов("УникальныйИдентификатор"));
	Таблица.Колонки.Добавить("УникальныйИдентификаторНоменклатур", Новый ОписаниеТипов("Строка"));
	Таблица.Колонки.Добавить("Состав", Новый ОписаниеТипов("Строка"));
	Таблица.Колонки.Добавить("УникальныйИдентификаторСклад", Новый ОписаниеТипов("УникальныйИдентификатор"));
	
	Для Каждого Строка Из Таблица Цикл
		
		Строка.Товары.Свернуть("Номенклатура,НоменклатураНаименование", "Количество");
		Строка.Товары.Сортировать("Номенклатура Возр");
		Строка.УникальныйИдентификатор = Строка.Ссылка.УникальныйИдентификатор();
		Строка.УникальныйИдентификаторНоменклатур
			= ПолучитьСтроковыйИдентификаторТЧДляСравнения(Строка.Товары
			, "Номенклатура,Количество");
		Строка.Состав = ПолучитьПредставлениеТЧ(Строка.Товары
			, "НоменклатураНаименование,Количество");
		
	КонецЦикла;
	
	
	Если Не ВключитьСсылочныеКолонки Тогда
		
		Таблица.Колонки.Удалить("Ссылка");
		
	КонецЕсли;
	
	Таблица.Колонки.Удалить("Товары");
	Таблица.Колонки.Удалить("Склад");
	
	Возврат Таблица;
	
КонецФункции

Функция ПолучитьТаблицуДенежныеДокументы(Параметры = Неопределено, ВключитьСсылочныеКолонки = Ложь)
	
	Запрос = Новый Запрос;
	Запрос.Текст = 
	"ВЫБРАТЬ
	|	ДенежныеДокументы.Ссылка КАК Ссылка,
	|	ДенежныеДокументы.Наименование КАК Наименование,
	|	ДенежныеДокументы.Цена КАК Стоимость
	|ИЗ
	|	Справочник.ДенежныеДокументы КАК ДенежныеДокументы
	|УПОРЯДОЧИТЬ ПО Наименование ВОЗР";
	
	Таблица = Запрос.Выполнить().Выгрузить();
	Таблица.Колонки.Добавить("УникальныйИдентификатор", Новый ОписаниеТипов("УникальныйИдентификатор"));
	
	Для Каждого Строка Из Таблица Цикл
		
		Строка.УникальныйИдентификатор = Строка.Ссылка.УникальныйИдентификатор();
		
	КонецЦикла;
	
	
	Если Не ВключитьСсылочныеКолонки Тогда
		Таблица.Колонки.Удалить("Ссылка");
	КонецЕсли;
	
	ПреобразоватьСумму(Таблица);
	
	Возврат Таблица;
	
КонецФункции

Функция ПолучитьТаблицуКорректировкаРеализации(Параметры = Неопределено, ВключитьСсылочныеКолонки = Ложь)
	
	Построитель = Новый ПостроительЗапроса(
	"ВЫБРАТЬ
	|	КорректировкаРеализации.Ссылка КАК Ссылка,
	|	Представление(КорректировкаРеализации.Ссылка) КАК Представление,
	|	КорректировкаРеализации.Номер КАК Номер,
	|	ГОД(КорректировкаРеализации.Дата) КАК Год,
	|	КорректировкаРеализации.Дата КАК ДатаДляОтбора,
	|	КорректировкаРеализации.Подразделение КАК Подразделение,
	|	КорректировкаРеализации.Подразделение.Наименование КАК ПодразделениеНаименование,
	|	КорректировкаРеализации.Контрагент.Наименование КАК КонтрагентНаименование,
	|	КорректировкаРеализации.Товары.(Номенклатура, Номенклатура.Наименование, Количество,Сумма) КАК Товары
	|ИЗ
	|	Документ.КорректировкаРеализации КАК КорректировкаРеализации
	|{ГДЕ
	|	Ссылка.Дата КАК Дата
	|}
	|УПОРЯДОЧИТЬ ПО 
	|	Номер ВОЗР
	|");
	
	Если Параметры <> Неопределено
		И Параметры.Свойство("Период") Тогда 
		ЭлементОтбора = Построитель.Отбор.Добавить("Дата");
		ЭлементОтбора.Использование = Истина;
		ЭлементОтбора.ВидСравнения = ВидСравнения.ИнтервалВключаяГраницы;
		ЭлементОтбора.ЗначениеС = Параметры.Период.ДатаНачала;
		ЭлементОтбора.ЗначениеПо = Параметры.Период.ДатаОкончания;
	КонецЕсли;
	
	Запрос = Построитель.ПолучитьЗапрос();
	
	Таблица = Запрос.Выполнить().Выгрузить();
	Таблица.Колонки.Добавить("УникальныйИдентификатор", Новый ОписаниеТипов("УникальныйИдентификатор"));
	Таблица.Колонки.Добавить("УникальныйИдентификаторНоменклатур", Новый ОписаниеТипов("Строка"));
	Таблица.Колонки.Добавить("Состав", Новый ОписаниеТипов("Строка"));
	Таблица.Колонки.Добавить("УникальныйИдентификаторПодразделение", Новый ОписаниеТипов("УникальныйИдентификатор"));
	
	Для Каждого Строка Из Таблица Цикл
		
		Строка.Товары.Свернуть("Номенклатура,НоменклатураНаименование", "Количество,Сумма");
		Строка.Товары.Сортировать("Номенклатура Возр");
		Строка.УникальныйИдентификатор = Строка.Ссылка.УникальныйИдентификатор();
		Строка.УникальныйИдентификаторПодразделение = Строка.Подразделение.УникальныйИдентификатор();
		Строка.УникальныйИдентификаторНоменклатур = ПолучитьСтроковыйИдентификаторТЧДляСравнения(Строка.Товары, "Номенклатура,Сумма,Количество");
		Строка.Состав = ПолучитьПредставлениеТЧ(Строка.Товары, "НоменклатураНаименование,Количество");
		
	КонецЦикла;
	
	
	Если Не ВключитьСсылочныеКолонки Тогда
		
		Таблица.Колонки.Удалить("Ссылка");
		
	КонецЕсли;
	
	ПреобразоватьСумму(Таблица);
	
	Таблица.Колонки.Удалить("Подразделение");
	Таблица.Колонки.Удалить("Товары");
	
	Возврат Таблица;
	
КонецФункции

Функция ПолучитьТаблицуАвансовыйОтчет(Параметры = Неопределено, ВключитьСсылочныеКолонки = Ложь)
	
	Построитель = Новый ПостроительЗапроса(
	"ВЫБРАТЬ
	|	АвансовыйОтчет.Ссылка КАК Ссылка,
	|	Представление(АвансовыйОтчет.Ссылка) КАК Представление,
	|	ГОД(АвансовыйОтчет.Дата) КАК Год,
	|	АвансовыйОтчет.Дата КАК ДатаДляОтбора,
	|	АвансовыйОтчет.Номер КАК Номер,
	|	АвансовыйОтчет.СуммаИзрасходовано КАК Сумма,
	|	АвансовыйОтчет.Организация.Наименование КАК ОрганизацияНаименование,
	|	АвансовыйОтчет.Подразделение КАК Подразделение,
	|	АвансовыйОтчет.Подразделение.Наименование КАК ПодразделениеНаименование,
	|	АвансовыйОтчет.ПрочиеРасходы.(НомерВходящегоДокумента,ДатаВходящегоДокумента,Сумма) КАК ПрочиеРасходы,
	|	АвансовыйОтчет.ОплатаПоставщикам.(Контрагент,Сумма) КАК ОплатаПоставщикам
	|ИЗ
	|	Документ.АвансовыйОтчет КАК АвансовыйОтчет
	|{ГДЕ
	|	Ссылка.Дата КАК Дата
	|}
	|УПОРЯДОЧИТЬ ПО 
	|	Номер ВОЗР
	|");
	
	Если Параметры <> Неопределено
		И Параметры.Свойство("Период") Тогда 
		ЭлементОтбора = Построитель.Отбор.Добавить("Дата");
		ЭлементОтбора.Использование = Истина;
		ЭлементОтбора.ВидСравнения = ВидСравнения.ИнтервалВключаяГраницы;
		ЭлементОтбора.ЗначениеС = Параметры.Период.ДатаНачала;
		ЭлементОтбора.ЗначениеПо = Параметры.Период.ДатаОкончания;
	КонецЕсли;
	
	Запрос = Построитель.ПолучитьЗапрос();
	
	Таблица = Запрос.Выполнить().Выгрузить();
	Таблица.Колонки.Добавить("УникальныйИдентификатор", Новый ОписаниеТипов("УникальныйИдентификатор"));
	Таблица.Колонки.Добавить("УникальныйИдентификаторПодразделение", Новый ОписаниеТипов("УникальныйИдентификатор"));
	Таблица.Колонки.Добавить("УникальныйИдентификаторПрочиеРасходы", Новый ОписаниеТипов("Строка"));
	Таблица.Колонки.Добавить("УникальныйИдентификаторОплатаПоставщикам", Новый ОписаниеТипов("Строка"));
	Таблица.Колонки.Добавить("СоставПрочиеРасходы", Новый ОписаниеТипов("Строка"));
	Таблица.Колонки.Добавить("СоставОплатаПоставщикам", Новый ОписаниеТипов("Строка"));
	
	Для Каждого Строка Из Таблица Цикл
		
		Строка.ПрочиеРасходы.Свернуть("НомерВходящегоДокумента,ДатаВходящегоДокумента", "Сумма");
		Строка.ПрочиеРасходы.Сортировать("НомерВходящегоДокумента Возр");
		
		Строка.ОплатаПоставщикам.Свернуть("Контрагент", "Сумма");
		Строка.ОплатаПоставщикам.Сортировать("Контрагент Возр");
		
		Строка.УникальныйИдентификатор = Строка.Ссылка.УникальныйИдентификатор();
		Строка.УникальныйИдентификаторПрочиеРасходы = ПолучитьСтроковыйИдентификаторТЧДляСравнения(Строка.ПрочиеРасходы, "Сумма");
		Строка.УникальныйИдентификаторОплатаПоставщикам = ПолучитьСтроковыйИдентификаторТЧДляСравнения(Строка.ОплатаПоставщикам, "Контрагент,Сумма");
		Строка.УникальныйИдентификаторПодразделение = Строка.Подразделение.УникальныйИдентификатор();
		
		Строка.СоставПрочиеРасходы = ПолучитьПредставлениеТЧ(Строка.ПрочиеРасходы, "НомерВходящегоДокумента,ДатаВходящегоДокумента,Сумма");
		Строка.СоставОплатаПоставщикам = ПолучитьПредставлениеТЧ(Строка.ОплатаПоставщикам, "Контрагент,Сумма");
		
	КонецЦикла;
	
	Таблица.Колонки.Удалить("ПрочиеРасходы");
	Таблица.Колонки.Удалить("ОплатаПоставщикам");
	Таблица.Колонки.Удалить("Подразделение");
	
	Если Не ВключитьСсылочныеКолонки Тогда
		
		Таблица.Колонки.Удалить("Ссылка");
		
	КонецЕсли;
	
	ПреобразоватьСумму(Таблица);
	
	Возврат Таблица;
	
КонецФункции

Функция ПолучитьТаблицуПоступлениеБезналичныхДенежныхСредств(Параметры = Неопределено, ВключитьСсылочныеКолонки = Ложь)
	
	Построитель = Новый ПостроительЗапроса(
	"ВЫБРАТЬ
	|	ПоступлениеБезналичныхДенежныхСредств.Ссылка КАК Ссылка,
	|	Представление(ПоступлениеБезналичныхДенежныхСредств.Ссылка) КАК Представление,
	|	ГОД(ПоступлениеБезналичныхДенежныхСредств.Дата) КАК Год,
	|	ПоступлениеБезналичныхДенежныхСредств.Дата КАК ДатаДляОтбора,
	|	ПоступлениеБезналичныхДенежныхСредств.Номер КАК Номер,
	|	ПоступлениеБезналичныхДенежныхСредств.СуммаДокумента КАК Сумма,
	|	ПоступлениеБезналичныхДенежныхСредств.Контрагент КАК Контрагент,
	|	ПоступлениеБезналичныхДенежныхСредств.Контрагент.Наименование КАК КонтрагентНаименование,
	|	ПоступлениеБезналичныхДенежныхСредств.НомерВходящегоДокумента КАК НомерВходящегоДокумента,
	|	ПоступлениеБезналичныхДенежныхСредств.ДатаВходящегоДокумента КАК ДатаВходящегоДокумента,
	|	ПоступлениеБезналичныхДенежныхСредств.Подразделение КАК Подразделение,
	|	ПоступлениеБезналичныхДенежныхСредств.Подразделение.Наименование КАК ПодразделениеНаименование
	|ИЗ
	|	Документ.ПоступлениеБезналичныхДенежныхСредств КАК ПоступлениеБезналичныхДенежныхСредств
	|{ГДЕ
	|	Ссылка.Дата КАК Дата
	|}
	|УПОРЯДОЧИТЬ ПО 
	|	Номер ВОЗР
	|");
	
	Если Параметры <> Неопределено
		И Параметры.Свойство("Период") Тогда 
		ЭлементОтбора = Построитель.Отбор.Добавить("Дата");
		ЭлементОтбора.Использование = Истина;
		ЭлементОтбора.ВидСравнения = ВидСравнения.ИнтервалВключаяГраницы;
		ЭлементОтбора.ЗначениеС = Параметры.Период.ДатаНачала;
		ЭлементОтбора.ЗначениеПо = Параметры.Период.ДатаОкончания;
	КонецЕсли;
	
	Запрос = Построитель.ПолучитьЗапрос();
	
	Таблица = Запрос.Выполнить().Выгрузить();
	Таблица.Колонки.Добавить("УникальныйИдентификатор", Новый ОписаниеТипов("УникальныйИдентификатор"));
	Таблица.Колонки.Добавить("УникальныйИдентификаторКонтрагент", Новый ОписаниеТипов("УникальныйИдентификатор"));
	Таблица.Колонки.Добавить("УникальныйИдентификаторПодразделение", Новый ОписаниеТипов("УникальныйИдентификатор"));
	
	Для Каждого Строка Из Таблица Цикл
		
		Строка.УникальныйИдентификатор = Строка.Ссылка.УникальныйИдентификатор();
		Строка.УникальныйИдентификаторКонтрагент = Строка.Ссылка.УникальныйИдентификатор();
		Строка.УникальныйИдентификаторПодразделение = Строка.Ссылка.УникальныйИдентификатор();
		
	КонецЦикла;
	
	Таблица.Колонки.Удалить("Контрагент");
	Таблица.Колонки.Удалить("Подразделение");
	
	Если Не ВключитьСсылочныеКолонки Тогда
		Таблица.Колонки.Удалить("Ссылка");
	КонецЕсли;
	
	ПреобразоватьСумму(Таблица);
	
	Возврат Таблица;
	
КонецФункции

Функция ПолучитьТаблицуСписаниеБезналичныхДенежныхСредств(Параметры = Неопределено, ВключитьСсылочныеКолонки = Ложь)
	
	Построитель = Новый ПостроительЗапроса(
	"ВЫБРАТЬ
	|	СписаниеБезналичныхДенежныхСредств.Ссылка КАК Ссылка,
	|	Представление(СписаниеБезналичныхДенежныхСредств.Ссылка) КАК Представление,
	|	ГОД(СписаниеБезналичныхДенежныхСредств.Дата) КАК Год,
	|	СписаниеБезналичныхДенежныхСредств.Дата КАК ДатаДляОтбора,
	|	СписаниеБезналичныхДенежныхСредств.СуммаДокумента КАК Сумма,
	|	СписаниеБезналичныхДенежныхСредств.Контрагент.Наименование КАК КонтрагентНаименование
	|ИЗ
	|	Документ.СписаниеБезналичныхДенежныхСредств КАК СписаниеБезналичныхДенежныхСредств
	|{ГДЕ
	|	Ссылка.Дата КАК Дата
	|}
	|УПОРЯДОЧИТЬ ПО 
	|	Номер ВОЗР
	|");
	
	Если Параметры <> Неопределено
		И Параметры.Свойство("Период") Тогда 
		ЭлементОтбора = Построитель.Отбор.Добавить("Дата");
		ЭлементОтбора.Использование = Истина;
		ЭлементОтбора.ВидСравнения = ВидСравнения.ИнтервалВключаяГраницы;
		ЭлементОтбора.ЗначениеС = Параметры.Период.ДатаНачала;
		ЭлементОтбора.ЗначениеПо = Параметры.Период.ДатаОкончания;
	КонецЕсли;
	
	Запрос = Построитель.ПолучитьЗапрос();
	
	Таблица = Запрос.Выполнить().Выгрузить();
	Таблица.Колонки.Добавить("УникальныйИдентификатор", Новый ОписаниеТипов("УникальныйИдентификатор"));
	
	Для Каждого Строка Из Таблица Цикл
		
		Строка.УникальныйИдентификатор = Строка.Ссылка.УникальныйИдентификатор();
		
	КонецЦикла;
	
	
	Если Не ВключитьСсылочныеКолонки Тогда
		
		Таблица.Колонки.Удалить("Ссылка");
		
	КонецЕсли;
	
	ПреобразоватьСумму(Таблица);
	
	Возврат Таблица;
	
КонецФункции

Функция ПолучитьТаблицуРесурсныеСпецификации(Параметры = Неопределено, ВключитьСсылочныеКолонки = Ложь)
	
	Запрос = Новый Запрос;
	Запрос.Текст = 
	"ВЫБРАТЬ
	|	РесурсныеСпецификации.Ссылка КАК Ссылка,
	|	РесурсныеСпецификации.Наименование КАК Наименование
	|ИЗ
	|	Справочник.РесурсныеСпецификации КАК РесурсныеСпецификации
	|УПОРЯДОЧИТЬ ПО Наименование ВОЗР";
	
	Таблица = Запрос.Выполнить().Выгрузить();
	Таблица.Колонки.Добавить("УникальныйИдентификатор", Новый ОписаниеТипов("УникальныйИдентификатор"));
	
	Для Каждого Строка Из Таблица Цикл
		
		Строка.УникальныйИдентификатор = Строка.Ссылка.УникальныйИдентификатор();
		
	КонецЦикла;
	
	
	Если Не ВключитьСсылочныеКолонки Тогда
		Таблица.Колонки.Удалить("Ссылка");
	КонецЕсли;
	
	Возврат Таблица;
	
КонецФункции

Функция ПолучитьТаблицуСтатьиДвиженияДенежныхСредств(Параметры = Неопределено, ВключитьСсылочныеКолонки = Ложь)
	
	Запрос = Новый Запрос;
	Запрос.Текст = 
	"ВЫБРАТЬ
	|	СтатьиДвиженияДенежныхСредств.Ссылка КАК Ссылка,
	|	СтатьиДвиженияДенежныхСредств.Наименование КАК Наименование
	|ИЗ
	|	Справочник.СтатьиДвиженияДенежныхСредств КАК СтатьиДвиженияДенежныхСредств
	|УПОРЯДОЧИТЬ ПО Наименование ВОЗР";
	
	Таблица = Запрос.Выполнить().Выгрузить();
	Таблица.Колонки.Добавить("УникальныйИдентификатор", Новый ОписаниеТипов("УникальныйИдентификатор"));
	
	Для Каждого Строка Из Таблица Цикл
		
		Строка.УникальныйИдентификатор = Строка.Ссылка.УникальныйИдентификатор();
		
	КонецЦикла;
	
	
	Если Не ВключитьСсылочныеКолонки Тогда
		Таблица.Колонки.Удалить("Ссылка");
	КонецЕсли;
	
	Возврат Таблица;
	
КонецФункции

Функция ПолучитьТаблицуСтруктураПредприятия(Параметры = Неопределено, ВключитьСсылочныеКолонки = Ложь)
	
	Запрос = Новый Запрос;
	Запрос.Текст = 
	"ВЫБРАТЬ
	|	СтруктураПредприятия.Ссылка КАК Ссылка,
	|	СтруктураПредприятия.Наименование КАК Наименование
	|ИЗ
	|	Справочник.СтруктураПредприятия КАК СтруктураПредприятия
	|УПОРЯДОЧИТЬ ПО Наименование ВОЗР";
	
	Таблица = Запрос.Выполнить().Выгрузить();
	Таблица.Колонки.Добавить("УникальныйИдентификатор", Новый ОписаниеТипов("УникальныйИдентификатор"));
	
	Для Каждого Строка Из Таблица Цикл
		
		Строка.УникальныйИдентификатор = Строка.Ссылка.УникальныйИдентификатор();
		
	КонецЦикла;
	
	
	Если Не ВключитьСсылочныеКолонки Тогда
		Таблица.Колонки.Удалить("Ссылка");
	КонецЕсли;
	
	Возврат Таблица;
	
КонецФункции

Функция ПолучитьТаблицуСтатьиРасходов(Параметры = Неопределено, ВключитьСсылочныеКолонки = Ложь)
	
	Запрос = Новый Запрос;
	Запрос.Текст = 
	"ВЫБРАТЬ
	|	СтатьиРасходов.Ссылка КАК Ссылка,
	|	СтатьиРасходов.Наименование КАК Наименование
	|ИЗ
	|	ПланВидовХарактеристик.СтатьиРасходов КАК СтатьиРасходов
	|ГДЕ
	|	СтатьиРасходов.СчетУчета <> ЗНАЧЕНИЕ(ПланСчетов.Хозрасчетный.ПустаяСсылка)
	|	И НЕ ПОДСТРОКА(СтатьиРасходов.СчетУчета.Код, 1, 2) = ""91""
	|УПОРЯДОЧИТЬ ПО Наименование ВОЗР";
	
	Таблица = Запрос.Выполнить().Выгрузить();
	Таблица.Колонки.Добавить("УникальныйИдентификатор", Новый ОписаниеТипов("УникальныйИдентификатор"));
	
	Для Каждого Строка Из Таблица Цикл
		
		Строка.УникальныйИдентификатор = Строка.Ссылка.УникальныйИдентификатор();
		
	КонецЦикла;
	
	
	Если Не ВключитьСсылочныеКолонки Тогда
		Таблица.Колонки.Удалить("Ссылка");
	КонецЕсли;
	
	Возврат Таблица;
	
КонецФункции

Функция ПолучитьТаблицуПрочиеДоходыИРасходы(Параметры = Неопределено, ВключитьСсылочныеКолонки = Ложь)
	
	Запрос = Новый Запрос;
	Запрос.Текст = 
	"ВЫБРАТЬ
	|	СтатьиРасходов.Ссылка КАК Ссылка,
	|	СтатьиРасходов.Наименование КАК Наименование
	|ИЗ
	|	ПланВидовХарактеристик.СтатьиРасходов КАК СтатьиРасходов
	|ГДЕ
	|	СтатьиРасходов.СчетУчета = ЗНАЧЕНИЕ(ПланСчетов.Хозрасчетный.ПустаяСсылка)
	|	И ПОДСТРОКА(СтатьиРасходов.СчетУчета.Код, 1, 2) = ""91""
	|
	|ОБЪЕДИНИТЬ ВСЕ
	|	
	|ВЫБРАТЬ
	|	СтатьиДоходов.Ссылка,
	|	СтатьиДоходов.Наименование
	|ИЗ
	|	ПланВидовХарактеристик.СтатьиДоходов КАК СтатьиДоходов
	|
	|УПОРЯДОЧИТЬ ПО Наименование ВОЗР";
	
	Таблица = Запрос.Выполнить().Выгрузить();
	Таблица.Колонки.Добавить("УникальныйИдентификатор", Новый ОписаниеТипов("УникальныйИдентификатор"));
	
	Для Каждого Строка Из Таблица Цикл
		
		Строка.УникальныйИдентификатор = Строка.Ссылка.УникальныйИдентификатор();
		
	КонецЦикла;
	
	
	Если Не ВключитьСсылочныеКолонки Тогда
		Таблица.Колонки.Удалить("Ссылка");
	КонецЕсли;
	
	Возврат Таблица;
	
КонецФункции

Функция ПолучитьТаблицуБанковскиеСчетаКонтрагентов(Параметры = Неопределено, ВключитьСсылочныеКолонки = Ложь)
	
	Запрос = Новый Запрос;
	Запрос.Текст = 
	"ВЫБРАТЬ
	|	БанковскиеСчетаКонтрагентов.Ссылка КАК Ссылка,
	|	БанковскиеСчетаКонтрагентов.Наименование КАК Наименование,
	|	БанковскиеСчетаКонтрагентов.ВалютаДенежныхСредств.Код КАК Валюта,
	|	БанковскиеСчетаКонтрагентов.НомерСчета КАК НомерСчета,
	|	БанковскиеСчетаКонтрагентов.Банк.Код КАК БИК
	|ИЗ
	|	Справочник.БанковскиеСчетаКонтрагентов КАК БанковскиеСчетаКонтрагентов
	|ГДЕ
	|	БанковскиеСчетаКонтрагентов.Владелец ССЫЛКА Справочник.Контрагенты
	|УПОРЯДОЧИТЬ ПО Наименование ВОЗР";
	
	Таблица = Запрос.Выполнить().Выгрузить();
	Таблица.Колонки.Добавить("УникальныйИдентификатор", Новый ОписаниеТипов("УникальныйИдентификатор"));
	
	Для Каждого Строка Из Таблица Цикл
		
		Строка.УникальныйИдентификатор = Строка.Ссылка.УникальныйИдентификатор();
		
	КонецЦикла;
	
	
	Если Не ВключитьСсылочныеКолонки Тогда
		Таблица.Колонки.Удалить("Ссылка");
	КонецЕсли;
	
	Возврат Таблица;
	
КонецФункции

Функция ПолучитьТаблицуПрочееОприходованиеТоваровВозвратИзЭксплуатации(Параметры = Неопределено, ВключитьСсылочныеКолонки = Ложь)
	
	Построитель = Новый ПостроительЗапроса(
	"ВЫБРАТЬ
	|	ПрочееОприходованиеТоваров.Ссылка КАК Ссылка,
	|	Представление(ПрочееОприходованиеТоваров.Ссылка) КАК Представление,
	|	НАЧАЛОПЕРИОДА(ПрочееОприходованиеТоваров.Дата, ДЕНЬ) КАК ДатаДокумента,
	|	ПрочееОприходованиеТоваров.Дата КАК ДатаДляОтбора,
	|	ПрочееОприходованиеТоваров.Номер КАК Номер,
	|	ПрочееОприходованиеТоваров.Склад КАК Склад,
	|	ПрочееОприходованиеТоваров.Склад.Наименование КАК СкладНаименование,
	|	ПрочееОприходованиеТоваров.Подразделение КАК Подразделение,
	|	ПрочееОприходованиеТоваров.Подразделение.Наименование КАК ПодразделениеНаименование,
	|	ПрочееОприходованиеТоваров.Товары.(Номенклатура, Номенклатура.Наименование, Количество,Сумма,ФизическоеЛицо) КАК Товары
	|ИЗ
	|	Документ.ПрочееОприходованиеТоваров КАК ПрочееОприходованиеТоваров
	|ГДЕ
	|	ПрочееОприходованиеТоваров.ХозяйственнаяОперация 
	|		= ЗНАЧЕНИЕ(Перечисление.ХозяйственныеОперации.ВозвратИзЭксплуатации)
	|{ГДЕ
	|	Ссылка.Дата КАК Дата
	|}
	|УПОРЯДОЧИТЬ ПО 
	|	Номер ВОЗР
	|");
	
	Если Параметры <> Неопределено
		И Параметры.Свойство("Период") Тогда 
		ЭлементОтбора = Построитель.Отбор.Добавить("Дата");
		ЭлементОтбора.Использование = Истина;
		ЭлементОтбора.ВидСравнения = ВидСравнения.ИнтервалВключаяГраницы;
		ЭлементОтбора.ЗначениеС = Параметры.Период.ДатаНачала;
		ЭлементОтбора.ЗначениеПо = Параметры.Период.ДатаОкончания;
	КонецЕсли;
	
	Запрос = Построитель.ПолучитьЗапрос();
	
	Таблица = Запрос.Выполнить().Выгрузить();
	Таблица.Колонки.Добавить("УникальныйИдентификатор", Новый ОписаниеТипов("УникальныйИдентификатор"));
	Таблица.Колонки.Добавить("УникальныйИдентификаторСклад", Новый ОписаниеТипов("УникальныйИдентификатор"));
	Таблица.Колонки.Добавить("УникальныйИдентификаторПодразделение", Новый ОписаниеТипов("УникальныйИдентификатор"));
	Таблица.Колонки.Добавить("УникальныйИдентификаторНоменклатур", Новый ОписаниеТипов("Строка"));
	Таблица.Колонки.Добавить("Состав", Новый ОписаниеТипов("Строка"));
	
	
	Для Каждого Строка Из Таблица Цикл
		
		Строка.Товары.Свернуть("Номенклатура,НоменклатураНаименование,ФизическоеЛицо", "Количество,Сумма");
		Строка.Товары.Сортировать("Номенклатура Возр");
		
		Строка.УникальныйИдентификатор = Строка.Ссылка.УникальныйИдентификатор();
		Строка.УникальныйИдентификаторСклад = Строка.Склад.УникальныйИдентификатор();
		Строка.УникальныйИдентификаторПодразделение = Строка.Подразделение.УникальныйИдентификатор();
		
		Строка.УникальныйИдентификаторНоменклатур = ПолучитьСтроковыйИдентификаторТЧДляСравнения(Строка.Товары, "Номенклатура,Количество,Сумма,ФизическоеЛицо");
		Строка.Состав = ПолучитьПредставлениеТЧ(Строка.Товары, "НоменклатураНаименование,Количество,Сумма,ФизическоеЛицо");
		
	КонецЦикла;
	
	
	Если Не ВключитьСсылочныеКолонки Тогда
		
		Таблица.Колонки.Удалить("Ссылка");
		
	КонецЕсли;
	
	Таблица.Колонки.Удалить("Товары");
	Таблица.Колонки.Удалить("Склад");
	Таблица.Колонки.Удалить("Подразделение");
	
	ПреобразоватьСумму(Таблица);
	
	Возврат Таблица;
	
КонецФункции

Функция ПолучитьТаблицуПриобретениеТоваровУслуг(Параметры, ВключитьСсылочныеКолонки = Ложь)
	
	Построитель = Новый ПостроительЗапроса("
	|ВЫБРАТЬ
	|	Контрагент КАК Поставщик,
	|	Представление(Ссылка) КАК Представление,
	|	Контрагент.Наименование КАК ПоставщикНаименование,
	|	Дата КАК ДатаДляОтбора,
	|	Дата КАК Дата,
	|	АвансовыйОтчет,
	|	НаименованиеВходящегоДокумента,
	|	НомерВходящегоДокумента,
	|	ДатаВходящегоДокумента,
	|	Товары.(
	|		Номенклатура КАК Номенклатура,
	|		Номенклатура.Наименование КАК НоменклатураНаименование,
	|		Количество КАК Количество
	|	)
	|ИЗ
	|	Документ.ПриобретениеТоваровУслуг КАК ПриобретениеТоваровУслуг
	|ГДЕ
	|	АвансовыйОтчет.Ссылка ЕСТЬ НЕ NULL
	|{ГДЕ
	|	Ссылка.Дата КАК Дата
	|}
	|");
	
	Если Параметры <> Неопределено
		И Параметры.Свойство("Период") Тогда 
		ЭлементОтбора = Построитель.Отбор.Добавить("Дата");
		ЭлементОтбора.Использование = Истина;
		ЭлементОтбора.ВидСравнения = ВидСравнения.ИнтервалВключаяГраницы;
		ЭлементОтбора.ЗначениеС = Параметры.Период.ДатаНачала;
		ЭлементОтбора.ЗначениеПо = Параметры.Период.ДатаОкончания;
	КонецЕсли;
	
	Построитель.Выполнить();
	
	
	
	Таблица = Новый ТаблицаЗначений;
	Таблица.Колонки.Добавить("Поставщик", Новый ОписаниеТипов("СправочникСсылка.Контрагенты"));
	Таблица.Колонки.Добавить("ПоставщикGUID", Новый ОписаниеТипов("Строка"));
	Таблица.Колонки.Добавить("ДатаДляОтбора", Новый ОписаниеТипов("Дата"));
	Таблица.Колонки.Добавить("Представление", Новый ОписаниеТипов("Строка"));
	Таблица.Колонки.Добавить("ПоставщикНаименование", Новый ОписаниеТипов("Строка"));
	Таблица.Колонки.Добавить("АвансовыйОтчет", Новый ОписаниеТипов("ДокументСсылка.АвансовыйОтчет"));
	Таблица.Колонки.Добавить("АвансовыйОтчетGUID", Новый ОписаниеТипов("Строка"));
	Таблица.Колонки.Добавить("НаименованиеВходящегоДокумента", Новый ОписаниеТипов("Строка"));
	Таблица.Колонки.Добавить("НомерВходящегоДокумента", Новый ОписаниеТипов("Строка"));
	Таблица.Колонки.Добавить("ДатаВходящегоДокумента", Новый ОписаниеТипов("Строка"));
	Таблица.Колонки.Добавить("СоставДляСравнения", Новый ОписаниеТипов("Строка"));
	Таблица.Колонки.Добавить("Состав", Новый ОписаниеТипов("Строка"));
	
	ВыборкаДокументов = Построитель.Результат.Выбрать();
	
	Пока ВыборкаДокументов.Следующий() Цикл 
		
		Состав = Новый Массив;
		СоставДляСравнения = Новый Массив;
		
		ТаблицаТоваров = ВыборкаДокументов.Товары.Выгрузить();
		ТаблицаТоваров.Свернуть("Номенклатура, НоменклатураНаименование", "Количество");
		ТаблицаТоваров.Сортировать("Номенклатура");
		
		Для Каждого СтрокаТаблицыТоваров Из ТаблицаТоваров Цикл 
			
			Состав.Добавить(СтрШаблон("%1 (%2)"
			, СтрокаТаблицыТоваров.НоменклатураНаименование
			, Формат(СтрокаТаблицыТоваров.Количество, "ЧН=")
			));
			
			СоставДляСравнения.Добавить(СтрШаблон("%1|%2"
			, Строка(СтрокаТаблицыТоваров.Номенклатура.УникальныйИдентификатор())
			, Формат(СтрокаТаблицыТоваров.Количество, "ЧН=")
			));
			
		КонецЦикла;
		
		СтрокаТаблицы = Таблица.Добавить();
		ЗаполнитьЗначенияСвойств(СтрокаТаблицы, ВыборкаДокументов);
		//СтрокаТаблицы.ДатаДляОтбора = 
		СтрокаТаблицы.ПоставщикGUID = СтрокаТаблицы.Поставщик.УникальныйИдентификатор();
		СтрокаТаблицы.АвансовыйОтчетGUID = СтрокаТаблицы.АвансовыйОтчет.УникальныйИдентификатор();
		СтрокаТаблицы.СоставДляСравнения = СтрСоединить(СоставДляСравнения, "||");
		СтрокаТаблицы.Состав = СтрСоединить(Состав, Символы.ПС);
		
	КонецЦикла;
	
	
	Если Не ВключитьСсылочныеКолонки Тогда 
		Таблица.Колонки.Удалить("Поставщик");
		Таблица.Колонки.Удалить("АвансовыйОтчет");
	КонецЕсли;
	
	Возврат Таблица;
	
КонецФункции

Функция ПолучитьТаблицуОприходованиеИзлишковТоваров(Параметры = Неопределено, ВключитьСсылочныеКолонки = Ложь)
	
	Построитель = Новый ПостроительЗапроса(
	"ВЫБРАТЬ
	|	ОприходованиеИзлишковТоваров.Ссылка КАК Ссылка,
	|	Представление(ОприходованиеИзлишковТоваров.Ссылка) КАК Представление,
	|	ГОД(ОприходованиеИзлишковТоваров.Дата) КАК Год,
	|	ОприходованиеИзлишковТоваров.Дата КАК ДатаДляОтбора,
	|	ОприходованиеИзлишковТоваров.Номер КАК Номер,
	|	ОприходованиеИзлишковТоваров.Склад КАК Склад,
	|	ОприходованиеИзлишковТоваров.Склад.Наименование КАК СкладНаименование,
	|	ОприходованиеИзлишковТоваров.Подразделение КАК Подразделение,
	|	ОприходованиеИзлишковТоваров.Подразделение.Наименование КАК ПодразделениеНаименование,
	|	ОприходованиеИзлишковТоваров.СтатьяДоходов КАК СтатьяДоходов,
	|	ОприходованиеИзлишковТоваров.СтатьяДоходов.Наименование КАК СтатьяДоходовНаименование,
	|	ОприходованиеИзлишковТоваров.Товары.(Номенклатура, Номенклатура.Наименование, Количество,Сумма) КАК Товары
	|ИЗ
	|	Документ.ОприходованиеИзлишковТоваров КАК ОприходованиеИзлишковТоваров
	|{ГДЕ
	|	Ссылка.Дата КАК Дата
	|}
	|УПОРЯДОЧИТЬ ПО 
	|	Номер ВОЗР
	|");
	
	Если Параметры <> Неопределено
		И Параметры.Свойство("Период") Тогда 
		ЭлементОтбора = Построитель.Отбор.Добавить("Дата");
		ЭлементОтбора.Использование = Истина;
		ЭлементОтбора.ВидСравнения = ВидСравнения.ИнтервалВключаяГраницы;
		ЭлементОтбора.ЗначениеС = Параметры.Период.ДатаНачала;
		ЭлементОтбора.ЗначениеПо = Параметры.Период.ДатаОкончания;
	КонецЕсли;
	
	Запрос = Построитель.ПолучитьЗапрос();
	
	Таблица = Запрос.Выполнить().Выгрузить();
	Таблица.Колонки.Добавить("УникальныйИдентификатор", Новый ОписаниеТипов("УникальныйИдентификатор"));
	Таблица.Колонки.Добавить("УникальныйИдентификаторПодразделение", Новый ОписаниеТипов("УникальныйИдентификатор"));
	Таблица.Колонки.Добавить("УникальныйИдентификаторСклад", Новый ОписаниеТипов("УникальныйИдентификатор"));
	Таблица.Колонки.Добавить("УникальныйИдентификаторСтатьяДоходов", Новый ОписаниеТипов("УникальныйИдентификатор"));
	Таблица.Колонки.Добавить("УникальныйИдентификаторНоменклатур", Новый ОписаниеТипов("Строка"));
	Таблица.Колонки.Добавить("Состав", Новый ОписаниеТипов("Строка"));
	
	Для Каждого Строка Из Таблица Цикл
		
		Строка.Товары.Свернуть("Номенклатура,НоменклатураНаименование", "Количество,Сумма");
		Строка.Товары.Сортировать("Номенклатура Возр");
		Строка.УникальныйИдентификатор = Строка.Ссылка.УникальныйИдентификатор();
		Строка.УникальныйИдентификаторПодразделение = Строка.Подразделение.УникальныйИдентификатор();
		Строка.УникальныйИдентификаторСклад = Строка.Склад.УникальныйИдентификатор();
		Строка.УникальныйИдентификаторСтатьяДоходов = Строка.СтатьяДоходов.УникальныйИдентификатор();
		Строка.УникальныйИдентификаторНоменклатур = ПолучитьСтроковыйИдентификаторТЧДляСравнения(Строка.Товары, "Номенклатура,Количество,Сумма");
		Строка.Состав = ПолучитьПредставлениеТЧ(Строка.Товары, "НоменклатураНаименование,Количество,Сумма");
		
	КонецЦикла;
	
	
	Если Не ВключитьСсылочныеКолонки Тогда
		
		Таблица.Колонки.Удалить("Ссылка");
	КонецЕсли;
	
	Таблица.Колонки.Удалить("Товары");
	Таблица.Колонки.Удалить("Склад");
	Таблица.Колонки.Удалить("Подразделение");
	Таблица.Колонки.Удалить("СтатьяДоходов");
	
	ПреобразоватьСумму(Таблица);
	
	Возврат Таблица;
	
КонецФункции

Функция ПолучитьТаблицуРеализацияТоваровУслуг(Параметры = Неопределено, ВключитьСсылочныеКолонки = Ложь)
	
	Построитель = Новый ПостроительЗапроса(
	"ВЫБРАТЬ
	|	РеализацияТоваровУслуг.Ссылка КАК Ссылка,
	|	Представление(РеализацияТоваровУслуг.Ссылка) КАК Представление,
	|	РеализацияТоваровУслуг.Номер КАК Номер,
	|	НАЧАЛОПЕРИОДА(РеализацияТоваровУслуг.Дата, ДЕНЬ) КАК Дата,
	|	РеализацияТоваровУслуг.Дата КАК ДатаДляОтбора,
	|	РеализацияТоваровУслуг.СуммаДокумента КАК СуммаДокумента,
	|	РеализацияТоваровУслуг.Склад КАК Склад,
	|	РеализацияТоваровУслуг.Склад.Наименование КАК СкладНаименование,
	|	РеализацияТоваровУслуг.Договор КАК Договор,
	|	ПРЕДСТАВЛЕНИЕ(РеализацияТоваровУслуг.Договор) КАК ДоговорНаименование,
	|	РеализацияТоваровУслуг.Контрагент КАК Контрагент,
	|	РеализацияТоваровУслуг.Контрагент.Наименование КАК КонтрагентНаименование,
	|	РеализацияТоваровУслуг.Товары.(Номенклатура, Номенклатура.Наименование, Количество,Сумма, СтавкаНДС,СуммаНДС) КАК Товары
	|ИЗ
	|	Документ.РеализацияТоваровУслуг КАК РеализацияТоваровУслуг
	|{ГДЕ
	|	Ссылка.Дата КАК Дата
	|}
	|УПОРЯДОЧИТЬ ПО 
	|	Номер ВОЗР
	|");
	
	Если Параметры <> Неопределено
		И Параметры.Свойство("Период") Тогда 
		ЭлементОтбора = Построитель.Отбор.Добавить("Дата");
		ЭлементОтбора.Использование = Истина;
		ЭлементОтбора.ВидСравнения = ВидСравнения.ИнтервалВключаяГраницы;
		ЭлементОтбора.ЗначениеС = Параметры.Период.ДатаНачала;
		ЭлементОтбора.ЗначениеПо = Параметры.Период.ДатаОкончания;
	КонецЕсли;
	
	Запрос = Построитель.ПолучитьЗапрос();
	
	Таблица = Запрос.Выполнить().Выгрузить();
	Таблица.Колонки.Добавить("УникальныйИдентификатор", Новый ОписаниеТипов("УникальныйИдентификатор"));
	Таблица.Колонки.Добавить("УникальныйИдентификаторСклад", Новый ОписаниеТипов("УникальныйИдентификатор"));
	Таблица.Колонки.Добавить("УникальныйИдентификаторДоговор", Новый ОписаниеТипов("УникальныйИдентификатор"));
	Таблица.Колонки.Добавить("УникальныйИдентификаторКонтрагент", Новый ОписаниеТипов("УникальныйИдентификатор"));
	Таблица.Колонки.Добавить("УникальныйИдентификаторНоменклатур", Новый ОписаниеТипов("Строка"));
	Таблица.Колонки.Добавить("Состав", Новый ОписаниеТипов("Строка"));
	
	Для Каждого Строка Из Таблица Цикл
		
		Строка.Товары.Свернуть("Номенклатура,НоменклатураНаименование,СтавкаНДС,СуммаНДС", "Количество,Сумма");
		Строка.Товары.Сортировать("Номенклатура Возр");
		
		Строка.Товары.Колонки.Добавить("СтавкаНДССтрокой");
		
		Для Каждого СтрокаТЧ Из Строка.Товары Цикл
			
			СтрокаТЧ.СтавкаНДССтрокой = ПреобразоватьПеречислениеВСтроку(СтрокаТЧ.СтавкаНДС);
			
		КонецЦикла;
		
		Строка.УникальныйИдентификатор = Строка.Ссылка.УникальныйИдентификатор();
		Строка.УникальныйИдентификаторСклад = Строка.Склад.УникальныйИдентификатор();
		Строка.УникальныйИдентификаторДоговор = Строка.Договор.УникальныйИдентификатор();
		Строка.УникальныйИдентификаторКонтрагент = Строка.Контрагент.УникальныйИдентификатор();
		Строка.УникальныйИдентификаторНоменклатур = ПолучитьСтроковыйИдентификаторТЧДляСравнения(Строка.Товары,"СтавкаНДССтрокой,Номенклатура,Количество,Сумма,СуммаНДС");
		Строка.Состав = ПолучитьПредставлениеТЧ(Строка.Товары, "НоменклатураНаименование,Количество,Сумма,СтавкаНДССтрокой,СуммаНДС");
		
	КонецЦикла;
	
	
	Если Не ВключитьСсылочныеКолонки Тогда
		
		Таблица.Колонки.Удалить("Ссылка");
		
	КонецЕсли;
	
	Таблица.Колонки.Удалить("Товары");
	Таблица.Колонки.Удалить("Контрагент");
	Таблица.Колонки.Удалить("Склад");
	Таблица.Колонки.Удалить("Договор");
	
	ПреобразоватьСумму(Таблица);
	
	Возврат Таблица;
	
КонецФункции

Функция ПолучитьТаблицуСчетФактураВыданный(Параметры = Неопределено, ВключитьСсылочныеКолонки = Ложь)
	
Построитель = Новый ПостроительЗапроса(
	"ВЫБРАТЬ
	|	СчетФактураВыданный.Ссылка КАК Ссылка,
	|	Представление(СчетФактураВыданный.Ссылка) КАК Представление,
	|	НАЧАЛОПЕРИОДА(СчетФактураВыданный.Дата, ДЕНЬ) КАК Дата,
	|	СчетФактураВыданный.Дата КАК ДатаДляОтбора,
	|	СчетФактураВыданный.Номер КАК Номер,
	|	СчетФактураВыданный.Контрагент КАК Контрагент,
	|	СчетФактураВыданный.Контрагент.Наименование КАК КонтрагентНаименование
	|ИЗ
	|	Документ.СчетФактураВыданный КАК СчетФактураВыданный
	|{ГДЕ
	|	Ссылка.Дата КАК Дата
	|}
	|УПОРЯДОЧИТЬ ПО 
	|	Номер ВОЗР
	|");
	
	Если Параметры <> Неопределено
		И Параметры.Свойство("Период") Тогда 
		ЭлементОтбора = Построитель.Отбор.Добавить("Дата");
		ЭлементОтбора.Использование = Истина;
		ЭлементОтбора.ВидСравнения = ВидСравнения.ИнтервалВключаяГраницы;
		ЭлементОтбора.ЗначениеС = Параметры.Период.ДатаНачала;
		ЭлементОтбора.ЗначениеПо = Параметры.Период.ДатаОкончания;
	КонецЕсли;
	
	Запрос = Построитель.ПолучитьЗапрос();
	
	Таблица = Запрос.Выполнить().Выгрузить();
	Таблица.Колонки.Добавить("УникальныйИдентификатор", Новый ОписаниеТипов("УникальныйИдентификатор"));
	Таблица.Колонки.Добавить("УникальныйИдентификаторКонтрагент", Новый ОписаниеТипов("УникальныйИдентификатор"));
	
	Для Каждого Строка Из Таблица Цикл
		
		Строка.УникальныйИдентификатор = Строка.Ссылка.УникальныйИдентификатор();
		Строка.УникальныйИдентификаторКонтрагент = Строка.Контрагент.УникальныйИдентификатор();
		
	КонецЦикла;
	
	Таблица.Колонки.Удалить("Контрагент");
	
	Если Не ВключитьСсылочныеКолонки Тогда
		
		Таблица.Колонки.Удалить("Ссылка");
		
	КонецЕсли;
	
	Возврат Таблица;
	
КонецФункции

Функция ПолучитьТаблицуВыбытиеДенежныхДокументовПодотчетнику(Параметры = Неопределено, ВключитьСсылочныеКолонки = Ложь)
	
	Построитель = Новый ПостроительЗапроса(
	"ВЫБРАТЬ
	|	ВыбытиеДенежныхДокументов.Ссылка КАК Ссылка,
	|	Представление(ВыбытиеДенежныхДокументов.Ссылка) КАК Представление,
	|	ГОД(ВыбытиеДенежныхДокументов.Дата) КАК Год,
	|	ВыбытиеДенежныхДокументов.Дата КАК ДатаДляОтбора,
	|	ВыбытиеДенежныхДокументов.Номер КАК Номер,
	|	ВыбытиеДенежныхДокументов.ПодотчетноеЛицо КАК Контрагент,
	|	ВыбытиеДенежныхДокументов.ПодотчетноеЛицо.Наименование КАК КонтрагентНаименование,
	|	ВыбытиеДенежныхДокументов.ДенежныеДокументы.(ДенежныйДокумент,Количество,Сумма) КАК ДенежныеДокументы
	|ИЗ
	|	Документ.ВыбытиеДенежныхДокументов КАК ВыбытиеДенежныхДокументов
	|ГДЕ
	|	ВыбытиеДенежныхДокументов.ХозяйственнаяОперация = 
	|		ЗНАЧЕНИЕ(Перечисление.ХозяйственныеОперации.ВыдачаДенежныхДокументовПодотчетнику)
	|{ГДЕ
	|	ВыбытиеДенежныхДокументов.Ссылка.Дата КАК Дата
	|}
	|УПОРЯДОЧИТЬ ПО 
	|	Номер ВОЗР
	|");
	
	Если Параметры <> Неопределено
		И Параметры.Свойство("Период") Тогда 
		ЭлементОтбора = Построитель.Отбор.Добавить("Дата");
		ЭлементОтбора.Использование = Истина;
		ЭлементОтбора.ВидСравнения = ВидСравнения.ИнтервалВключаяГраницы;
		ЭлементОтбора.ЗначениеС = Параметры.Период.ДатаНачала;
		ЭлементОтбора.ЗначениеПо = Параметры.Период.ДатаОкончания;
	КонецЕсли;
	
	Запрос = Построитель.ПолучитьЗапрос();
	
	Таблица = Запрос.Выполнить().Выгрузить();
	Таблица.Колонки.Добавить("УникальныйИдентификатор", Новый ОписаниеТипов("УникальныйИдентификатор"));
	Таблица.Колонки.Добавить("УникальныйИдентификаторКонтрагент", Новый ОписаниеТипов("УникальныйИдентификатор"));
	Таблица.Колонки.Добавить("УникальныйИдентификаторНоменклатур", Новый ОписаниеТипов("Строка"));
	Таблица.Колонки.Добавить("Состав", Новый ОписаниеТипов("Строка"));
	
	Для Каждого Строка Из Таблица Цикл
		
		Строка.ДенежныеДокументы.Свернуть("ДенежныйДокумент", "Количество,Сумма");
		Строка.ДенежныеДокументы.Сортировать("ДенежныйДокумент Возр");
		
		Строка.УникальныйИдентификатор = Строка.Ссылка.УникальныйИдентификатор();
		Строка.УникальныйИдентификаторКонтрагент = Строка.Контрагент.УникальныйИдентификатор();
		
		Строка.УникальныйИдентификаторНоменклатур = ПолучитьСтроковыйИдентификаторТЧДляСравнения(Строка.ДенежныеДокументы,"ДенежныйДокумент,Количество,Сумма");
		Строка.Состав = ПолучитьПредставлениеТЧ(Строка.ДенежныеДокументы, "ДенежныйДокумент,Количество,Сумма");
		
	КонецЦикла;
	
	Таблица.Колонки.Удалить("Контрагент");
	Таблица.Колонки.Удалить("ДенежныеДокументы");
	
	Если Не ВключитьСсылочныеКолонки Тогда
		
		Таблица.Колонки.Удалить("Ссылка");
		
	КонецЕсли;
	
	ПреобразоватьСумму(Таблица);
	
	Возврат Таблица;
	
КонецФункции

Функция ПолучитьТаблицуВозвратДенежныхДокументовПоставщику(Параметры = Неопределено, ВключитьСсылочныеКолонки = Ложь)
	
Построитель = Новый ПостроительЗапроса(
	"ВЫБРАТЬ
	|	ВыбытиеДенежныхДокументов.Ссылка КАК Ссылка,
	|	Представление(ВыбытиеДенежныхДокументов.Ссылка) КАК Представление,
	|	ГОД(ВыбытиеДенежныхДокументов.Дата) КАК Год,
	|	ВыбытиеДенежныхДокументов.Дата КАК ДатаДляОтбора,
	|	ВыбытиеДенежныхДокументов.Номер КАК Номер,
	|	ВыбытиеДенежныхДокументов.СтатьяРасходов КАК СтатьяРасходов,
	|	ВыбытиеДенежныхДокументов.СтатьяРасходов.Наименование КАК СтатьяРасходовНаименование,
	|	ВыбытиеДенежныхДокументов.Контрагент КАК Контрагент,
	|	ВыбытиеДенежныхДокументов.Контрагент.Наименование КАК КонтрагентНаименование,
	|	ВыбытиеДенежныхДокументов.ДенежныеДокументы.(ДенежныйДокумент,Количество,Сумма) КАК ДенежныеДокументы
	|ИЗ
	|	Документ.ВыбытиеДенежныхДокументов КАК ВыбытиеДенежныхДокументов
	|ГДЕ
	|	ВыбытиеДенежныхДокументов.ХозяйственнаяОперация = 
	|		ЗНАЧЕНИЕ(Перечисление.ХозяйственныеОперации.ВозвратДенежныхДокументовПоставщику)
	|{ГДЕ
	|	Ссылка.Дата КАК Дата
	|}
	|УПОРЯДОЧИТЬ ПО 
	|	Номер ВОЗР
	|");
	
	Если Параметры <> Неопределено
		И Параметры.Свойство("Период") Тогда 
		ЭлементОтбора = Построитель.Отбор.Добавить("Дата");
		ЭлементОтбора.Использование = Истина;
		ЭлементОтбора.ВидСравнения = ВидСравнения.ИнтервалВключаяГраницы;
		ЭлементОтбора.ЗначениеС = Параметры.Период.ДатаНачала;
		ЭлементОтбора.ЗначениеПо = Параметры.Период.ДатаОкончания;
	КонецЕсли;
	
	Запрос = Построитель.ПолучитьЗапрос();
	
	Таблица = Запрос.Выполнить().Выгрузить();
	Таблица.Колонки.Добавить("УникальныйИдентификатор", Новый ОписаниеТипов("УникальныйИдентификатор"));
	Таблица.Колонки.Добавить("УникальныйИдентификаторСтатьяРасходов", Новый ОписаниеТипов("УникальныйИдентификатор"));
	Таблица.Колонки.Добавить("УникальныйИдентификаторКонтрагент", Новый ОписаниеТипов("УникальныйИдентификатор"));
	Таблица.Колонки.Добавить("УникальныйИдентификаторНоменклатур", Новый ОписаниеТипов("Строка"));
	Таблица.Колонки.Добавить("Состав", Новый ОписаниеТипов("Строка"));
	
	Для Каждого Строка Из Таблица Цикл
		
		Строка.ДенежныеДокументы.Свернуть("ДенежныйДокумент", "Количество,Сумма");
		Строка.ДенежныеДокументы.Сортировать("ДенежныйДокумент Возр");
		
		Строка.УникальныйИдентификатор = Строка.Ссылка.УникальныйИдентификатор();
		Строка.УникальныйИдентификаторКонтрагент = Строка.Контрагент.УникальныйИдентификатор();
		Строка.УникальныйИдентификаторСтатьяРасходов = Строка.СтатьяРасходов.УникальныйИдентификатор();
		
		Строка.УникальныйИдентификаторНоменклатур 
			= ПолучитьСтроковыйИдентификаторТЧДляСравнения(Строка.ДенежныеДокументы,"ДенежныйДокумент,Количество,Сумма");
		Строка.Состав = ПолучитьПредставлениеТЧ(Строка.ДенежныеДокументы, "ДенежныйДокумент,Количество,Сумма");
		
	КонецЦикла;
	
	Таблица.Колонки.Удалить("Контрагент");
	Таблица.Колонки.Удалить("ДенежныеДокументы");
	Таблица.Колонки.Удалить("СтатьяРасходов");
	
	Если Не ВключитьСсылочныеКолонки Тогда
		
		Таблица.Колонки.Удалить("Ссылка");
		
	КонецЕсли;
	
	ПреобразоватьСумму(Таблица);
	
	Возврат Таблица;
	
КонецФункции

Функция ПолучитьТаблицуВнутреннееПотреблениеТоваровПередачаВЭксплуатацию(Параметры = Неопределено, ВключитьСсылочныеКолонки = Ложь)
	
Построитель = Новый ПостроительЗапроса(
	"ВЫБРАТЬ
	|	ВнутреннееПотреблениеТоваров.Ссылка КАК Ссылка,
	|	Представление(ВнутреннееПотреблениеТоваров.Ссылка) КАК Представление,
	|	ВнутреннееПотреблениеТоваров.Номер КАК Номер,
	|	ВнутреннееПотреблениеТоваров.Дата КАК ДатаДляОтбора,
	|	ВнутреннееПотреблениеТоваров.Склад КАК Склад,
	|	ВнутреннееПотреблениеТоваров.Склад.Наименование КАК СкладНаименование,
	|	ВнутреннееПотреблениеТоваров.Подразделение КАК Подразделение,
	|	ВнутреннееПотреблениеТоваров.Подразделение.Наименование КАК ПодразделениеНаименование,
	|	ГОД(ВнутреннееПотреблениеТоваров.Дата) КАК Год,
	|	ВнутреннееПотреблениеТоваров.Товары.(Номенклатура, Номенклатура.Наименование, Количество,СтатьяРасходов,СтатьяРасходов.Наименование) КАК Товары
	|ИЗ
	|	Документ.ВнутреннееПотреблениеТоваров КАК ВнутреннееПотреблениеТоваров
	|ГДЕ
	|	ВнутреннееПотреблениеТоваров.ХозяйственнаяОперация = ЗНАЧЕНИЕ(Перечисление.ХозяйственныеОперации.ПередачаВЭксплуатацию)
	|{ГДЕ
	|	Ссылка.Дата КАК Дата
	|}
	|УПОРЯДОЧИТЬ ПО 
	|	Номер ВОЗР
	|");
	
	Если Параметры <> Неопределено
		И Параметры.Свойство("Период") Тогда 
		ЭлементОтбора = Построитель.Отбор.Добавить("Дата");
		ЭлементОтбора.Использование = Истина;
		ЭлементОтбора.ВидСравнения = ВидСравнения.ИнтервалВключаяГраницы;
		ЭлементОтбора.ЗначениеС = Параметры.Период.ДатаНачала;
		ЭлементОтбора.ЗначениеПо = Параметры.Период.ДатаОкончания;
	КонецЕсли;
	
	Запрос = Построитель.ПолучитьЗапрос();
	
	Таблица = Запрос.Выполнить().Выгрузить();
	Таблица.Колонки.Добавить("УникальныйИдентификатор", Новый ОписаниеТипов("УникальныйИдентификатор"));
	Таблица.Колонки.Добавить("УникальныйИдентификаторСклад", Новый ОписаниеТипов("УникальныйИдентификатор"));
	Таблица.Колонки.Добавить("УникальныйИдентификаторПодразделение", Новый ОписаниеТипов("УникальныйИдентификатор"));
	Таблица.Колонки.Добавить("УникальныйИдентификаторНоменклатур", Новый ОписаниеТипов("Строка"));
	Таблица.Колонки.Добавить("Состав", Новый ОписаниеТипов("Строка"));
	
	Для Каждого Строка Из Таблица Цикл
		
		Строка.Товары.Свернуть("Номенклатура,НоменклатураНаименование,СтатьяРасходов,СтатьяРасходовНаименование", "Количество");
		Строка.Товары.Сортировать("Номенклатура Возр");
		
		Строка.УникальныйИдентификатор = Строка.Ссылка.УникальныйИдентификатор();
		Строка.УникальныйИдентификаторСклад = Строка.Склад.УникальныйИдентификатор();
		Строка.УникальныйИдентификаторПодразделение= Строка.Подразделение.УникальныйИдентификатор();
		
		Строка.УникальныйИдентификаторНоменклатур = ПолучитьСтроковыйИдентификаторТЧДляСравнения(Строка.Товары, "Номенклатура,Количество,СтатьяРасходов");
		Строка.Состав = ПолучитьПредставлениеТЧ(Строка.Товары, "НоменклатураНаименование,Количество,СтатьяРасходовНаименование");
		
	КонецЦикла;
	
	
	Если Не ВключитьСсылочныеКолонки Тогда
		
		Таблица.Колонки.Удалить("Ссылка");
		
	КонецЕсли;
	
	Таблица.Колонки.Удалить("Склад");
	Таблица.Колонки.Удалить("Подразделение");
	Таблица.Колонки.Удалить("Товары");
	
	Возврат Таблица;
	
КонецФункции

Функция ПолучитьТаблицуВнутреннееПотреблениеТоваровСписаниеТоваровПоТребованию(Параметры = Неопределено, ВключитьСсылочныеКолонки = Ложь)
	
Построитель = Новый ПостроительЗапроса(
	"ВЫБРАТЬ
	|	ВнутреннееПотреблениеТоваров.Ссылка КАК Ссылка,
	|	Представление(ВнутреннееПотреблениеТоваров.Ссылка) КАК Представление,
	|	ГОД(ВнутреннееПотреблениеТоваров.Дата) КАК Год,
	|	ВнутреннееПотреблениеТоваров.Дата КАК ДатаДляОтбора,
	|	ВнутреннееПотреблениеТоваров.Номер КАК Номер,
	|	ВнутреннееПотреблениеТоваров.Склад КАК Склад,
	|	ВнутреннееПотреблениеТоваров.Склад.Наименование КАК СкладНаименование,
	|	ВнутреннееПотреблениеТоваров.Подразделение КАК Подразделение,
	|	ВнутреннееПотреблениеТоваров.Подразделение.Наименование КАК ПодразделениеНаименование,
	|	ВнутреннееПотреблениеТоваров.Товары.(Номенклатура, Номенклатура.Наименование, Количество,СтатьяРасходов) КАК Товары
	|ИЗ
	|	Документ.ВнутреннееПотреблениеТоваров КАК ВнутреннееПотреблениеТоваров
	|ГДЕ
	|	ВнутреннееПотреблениеТоваров.ХозяйственнаяОперация = ЗНАЧЕНИЕ(Перечисление.ХозяйственныеОперации.СписаниеТоваровПоТребованию)
	|{ГДЕ
	|	Ссылка.Дата КАК Дата
	|}
	|УПОРЯДОЧИТЬ ПО 
	|	Номер ВОЗР
	|");
	
	Если Параметры <> Неопределено
		И Параметры.Свойство("Период") Тогда 
		ЭлементОтбора = Построитель.Отбор.Добавить("Дата");
		ЭлементОтбора.Использование = Истина;
		ЭлементОтбора.ВидСравнения = ВидСравнения.ИнтервалВключаяГраницы;
		ЭлементОтбора.ЗначениеС = Параметры.Период.ДатаНачала;
		ЭлементОтбора.ЗначениеПо = Параметры.Период.ДатаОкончания;
	КонецЕсли;
	
	Запрос = Построитель.ПолучитьЗапрос();
	
	Таблица = Запрос.Выполнить().Выгрузить();
	Таблица.Колонки.Добавить("УникальныйИдентификатор", Новый ОписаниеТипов("УникальныйИдентификатор"));
	Таблица.Колонки.Добавить("УникальныйИдентификаторСклад", Новый ОписаниеТипов("УникальныйИдентификатор"));
	Таблица.Колонки.Добавить("УникальныйИдентификаторПодразделение", Новый ОписаниеТипов("УникальныйИдентификатор"));
	Таблица.Колонки.Добавить("УникальныйИдентификаторНоменклатур", Новый ОписаниеТипов("Строка"));
	Таблица.Колонки.Добавить("Состав", Новый ОписаниеТипов("Строка"));
	
	Для Каждого Строка Из Таблица Цикл
		
		Строка.Товары.Свернуть("Номенклатура,НоменклатураНаименование,СтатьяРасходов", "Количество");
		Строка.Товары.Сортировать("Номенклатура Возр");
		
		Строка.УникальныйИдентификатор = Строка.Ссылка.УникальныйИдентификатор();
		Строка.УникальныйИдентификаторСклад = Строка.Склад.УникальныйИдентификатор();
		Строка.УникальныйИдентификаторПодразделение = Строка.Подразделение.УникальныйИдентификатор();
		
		Строка.УникальныйИдентификаторНоменклатур = ПолучитьСтроковыйИдентификаторТЧДляСравнения(Строка.Товары, "Номенклатура,Количество,СтатьяРасходов");
		Строка.Состав = ПолучитьПредставлениеТЧ(Строка.Товары, "НоменклатураНаименование,Количество,СтатьяРасходов");
		
	КонецЦикла;
	
	
	Если Не ВключитьСсылочныеКолонки Тогда
		
		Таблица.Колонки.Удалить("Ссылка");
		
	КонецЕсли;
	
	Таблица.Колонки.Удалить("Товары");
	Таблица.Колонки.Удалить("Склад");
	Таблица.Колонки.Удалить("Подразделение");
	
	Возврат Таблица;
	
КонецФункции

Функция ПолучитьТаблицуДвижениеПродукцииИМатериалов(Параметры = Неопределено, ВключитьСсылочныеКолонки = Ложь)
	
Построитель = Новый ПостроительЗапроса(
	"ВЫБРАТЬ
	|	ДвижениеПродукцииИМатериалов.Ссылка КАК Ссылка,
	|	Представление(ДвижениеПродукцииИМатериалов.Ссылка) КАК Представление,
	|	ГОД(ДвижениеПродукцииИМатериалов.Дата) КАК Год,
	|	ДвижениеПродукцииИМатериалов.Дата КАК ДатаДляОтбора,
	|	ДвижениеПродукцииИМатериалов.Номер КАК Номер,
	|	ДвижениеПродукцииИМатериалов.Товары.(Номенклатура, Номенклатура.Наименование, Количество) КАК Товары
	|ИЗ
	|	Документ.ДвижениеПродукцииИМатериалов КАК ДвижениеПродукцииИМатериалов
	|ГДЕ
	|	ДвижениеПродукцииИМатериалов.ХозяйственнаяОперация = ЗНАЧЕНИЕ(Перечисление.ХозяйственныеОперации.ПередачаМатериаловВКладовую)
	|{ГДЕ
	|	Ссылка.Дата КАК Дата
	|}
	|УПОРЯДОЧИТЬ ПО 
	|	Номер ВОЗР
	|");
	
	Если Параметры <> Неопределено
		И Параметры.Свойство("Период") Тогда 
		ЭлементОтбора = Построитель.Отбор.Добавить("Дата");
		ЭлементОтбора.Использование = Истина;
		ЭлементОтбора.ВидСравнения = ВидСравнения.ИнтервалВключаяГраницы;
		ЭлементОтбора.ЗначениеС = Параметры.Период.ДатаНачала;
		ЭлементОтбора.ЗначениеПо = Параметры.Период.ДатаОкончания;
	КонецЕсли;
	
	Запрос = Построитель.ПолучитьЗапрос();
	
	Таблица = Запрос.Выполнить().Выгрузить();
	Таблица.Колонки.Добавить("УникальныйИдентификатор", Новый ОписаниеТипов("УникальныйИдентификатор"));
	Таблица.Колонки.Добавить("УникальныйИдентификаторНоменклатур", Новый ОписаниеТипов("Строка"));
	Таблица.Колонки.Добавить("Состав", Новый ОписаниеТипов("Строка"));
	
	Для Каждого Строка Из Таблица Цикл
		
		Строка.Товары.Свернуть("Номенклатура,НоменклатураНаименование", "Количество");
		Строка.Товары.Сортировать("Номенклатура Возр");
		
		Строка.УникальныйИдентификатор = Строка.Ссылка.УникальныйИдентификатор();
		Строка.УникальныйИдентификаторНоменклатур = ПолучитьСтроковыйИдентификаторТЧДляСравнения(Строка.Товары, "Номенклатура,Количество");
		Строка.Состав = ПолучитьПредставлениеТЧ(Строка.Товары, "НоменклатураНаименование,Количество");
		
	КонецЦикла;
	
	
	Если Не ВключитьСсылочныеКолонки Тогда
		
		Таблица.Колонки.Удалить("Ссылка");
		
	КонецЕсли;
	
	Таблица.Колонки.Удалить("Товары");
	
	Возврат Таблица;
	
КонецФункции

Функция ПолучитьТаблицуПроизводствоБезЗаказа(Параметры = Неопределено, ВключитьСсылочныеКолонки = Ложь)
	
Построитель = Новый ПостроительЗапроса(
	"ВЫБРАТЬ
	|	ПроизводствоБезЗаказа.Ссылка КАК Ссылка,
	|	Представление(ПроизводствоБезЗаказа.Ссылка) КАК Представление,
	|	ПроизводствоБезЗаказа.Номер КАК Номер, 
	|	ГОД(ПроизводствоБезЗаказа.Дата) КАК Год,
	|	ПроизводствоБезЗаказа.Дата КАК ДатаДляОтбора
	|ИЗ
	|	Документ.ПроизводствоБезЗаказа КАК ПроизводствоБезЗаказа
	|{ГДЕ
	|	Ссылка.Дата КАК Дата
	|}
	|УПОРЯДОЧИТЬ ПО 
	|	Номер ВОЗР
	|");
	
	Если Параметры <> Неопределено
		И Параметры.Свойство("Период") Тогда 
		ЭлементОтбора = Построитель.Отбор.Добавить("Дата");
		ЭлементОтбора.Использование = Истина;
		ЭлементОтбора.ВидСравнения = ВидСравнения.ИнтервалВключаяГраницы;
		ЭлементОтбора.ЗначениеС = Параметры.Период.ДатаНачала;
		ЭлементОтбора.ЗначениеПо = Параметры.Период.ДатаОкончания;
	КонецЕсли;
	
	Запрос = Построитель.ПолучитьЗапрос();
	
	Таблица = Запрос.Выполнить().Выгрузить();
	Таблица.Колонки.Добавить("УникальныйИдентификатор", Новый ОписаниеТипов("УникальныйИдентификатор"));
	
	
	Для Каждого Строка Из Таблица Цикл
		
		Строка.УникальныйИдентификатор = Строка.Ссылка.УникальныйИдентификатор();
		
	КонецЦикла;
	
	
	Если Не ВключитьСсылочныеКолонки Тогда
		
		Таблица.Колонки.Удалить("Ссылка");
		
	КонецЕсли;
	
	Возврат Таблица;
	
КонецФункции

Функция ПолучитьТаблицуПриобретениеТоваровУслугТовары(Параметры = Неопределено, ВключитьСсылочныеКолонки = Ложь)
	
	Построитель = Новый ПостроительЗапроса(
	"ВЫБРАТЬ
	|		ПТУ.Ссылка
	|	ПОМЕСТИТЬ
	|		ВТ
	|	ИЗ
	|		Документ.ПриобретениеТоваровУслуг.Товары КАК ПТУ
	|	ГДЕ
	|		ПТУ.НомерСтроки = 1
	|	;
	|	
	|	////////////////////////////////
	|	
	|	ВЫБРАТЬ
	|		ПриобретениеТоваровУслуг.Ссылка КАК Ссылка,
	|		Представление(ПриобретениеТоваровУслуг.Ссылка) КАК Представление,
	|		ГОД(ПриобретениеТоваровУслуг.Дата) КАК Год,
	|		ПриобретениеТоваровУслуг.Дата КАК ДатаДляОтбора,
	|		ПриобретениеТоваровУслуг.Товары.(Номенклатура, Номенклатура.Наименование, Количество) КАК Товары
	|	ИЗ
	|		Документ.ПриобретениеТоваровУслуг КАК ПриобретениеТоваровУслуг
	|	ВНУТРЕННЕЕ СОЕДИНЕНИЕ ВТ
	|		ПО ПриобретениеТоваровУслуг.Ссылка = ВТ.Ссылка
	|{ГДЕ
	|	ПриобретениеТоваровУслуг.Ссылка.Дата КАК Дата
	|}
	|	УПОРЯДОЧИТЬ ПО 
	|		Номер ВОЗР
	|");
	
	Если Параметры <> Неопределено
		И Параметры.Свойство("Период") Тогда 
		ЭлементОтбора = Построитель.Отбор.Добавить("Дата");
		ЭлементОтбора.Использование = Истина;
		ЭлементОтбора.ВидСравнения = ВидСравнения.ИнтервалВключаяГраницы;
		ЭлементОтбора.ЗначениеС = Параметры.Период.ДатаНачала;
		ЭлементОтбора.ЗначениеПо = Параметры.Период.ДатаОкончания;
	КонецЕсли;
	
	Запрос = Построитель.ПолучитьЗапрос();
	
	Таблица = Запрос.Выполнить().Выгрузить();
	Таблица.Колонки.Добавить("УникальныйИдентификатор", Новый ОписаниеТипов("УникальныйИдентификатор"));
	Таблица.Колонки.Добавить("УникальныйИдентификаторНоменклатур", Новый ОписаниеТипов("Строка"));
	Таблица.Колонки.Добавить("Состав", Новый ОписаниеТипов("Строка"));
	
	Для Каждого Строка Из Таблица Цикл
		
		Строка.Товары.Свернуть("Номенклатура,НоменклатураНаименование", "Количество");
		Строка.Товары.Сортировать("Номенклатура Возр");
		Строка.УникальныйИдентификатор = Строка.Ссылка.УникальныйИдентификатор();
		Строка.УникальныйИдентификаторНоменклатур = ПолучитьИдентификаторыКолонкиТЧ("Номенклатура", Строка.Товары);
		Строка.Состав = ПолучитьПредставлениеТЧ(Строка.Товары, "НоменклатураНаименование,Количество");
		
	КонецЦикла;
	
	
	Если Не ВключитьСсылочныеКолонки Тогда
		
		Таблица.Колонки.Удалить("Ссылка");
		
	КонецЕсли;
	
		Таблица.Колонки.Удалить("Товары");
	
	Возврат Таблица;
	
КонецФункции

Функция ПолучитьТаблицуПриобретениеУслугПрочихАктивов(Параметры = Неопределено, ВключитьСсылочныеКолонки = Ложь)
	
	Построитель = Новый ПостроительЗапроса(
	"ВЫБРАТЬ
	|	ПриобретениеУслугПрочихАктивов.Ссылка КАК Ссылка,
	|	Представление(ПриобретениеУслугПрочихАктивов.Ссылка) КАК Представление,
	|	ПриобретениеУслугПрочихАктивов.Номер КАК Номер,
	|	ГОД(ПриобретениеУслугПрочихАктивов.Дата) КАК Год,
	|	ПриобретениеУслугПрочихАктивов.Дата КАК ДатаДляОтбора
	|	ИЗ
	|		Документ.ПриобретениеУслугПрочихАктивов КАК ПриобретениеУслугПрочихАктивов
	|{ГДЕ
	|	Ссылка.Дата КАК Дата
	|}
	|	УПОРЯДОЧИТЬ ПО 
	|		Номер ВОЗР
	|");
	
	Если Параметры <> Неопределено
		И Параметры.Свойство("Период") Тогда 
		ЭлементОтбора = Построитель.Отбор.Добавить("Дата");
		ЭлементОтбора.Использование = Истина;
		ЭлементОтбора.ВидСравнения = ВидСравнения.ИнтервалВключаяГраницы;
		ЭлементОтбора.ЗначениеС = Параметры.Период.ДатаНачала;
		ЭлементОтбора.ЗначениеПо = Параметры.Период.ДатаОкончания;
	КонецЕсли;
	
	Запрос = Построитель.ПолучитьЗапрос();
	
	Таблица = Запрос.Выполнить().Выгрузить();
	Таблица.Колонки.Добавить("УникальныйИдентификатор", Новый ОписаниеТипов("УникальныйИдентификатор"));
	
	
	Для Каждого Строка Из Таблица Цикл
		
		Строка.УникальныйИдентификатор = Строка.Ссылка.УникальныйИдентификатор();
		
	КонецЦикла;
	
	
	Если Не ВключитьСсылочныеКолонки Тогда
		
		Таблица.Колонки.Удалить("Ссылка");
		
	КонецЕсли;
	
	Возврат Таблица;
	
КонецФункции

Функция ПолучитьТаблицуВнутреннееПотреблениеТоваровПринятиеОС(Параметры = Неопределено, ВключитьСсылочныеКолонки = Ложь)
	
	Построитель = Новый ПостроительЗапроса(
	"ВЫБРАТЬ
	|	ВнутреннееПотреблениеТоваров.Ссылка КАК Ссылка,
	|	Представление(ВнутреннееПотреблениеТоваров.Ссылка) КАК Представление,
	|	ГОД(ВнутреннееПотреблениеТоваров.Дата) КАК Год,
	|	ВнутреннееПотреблениеТоваров.Дата КАК ДатаДляОтбора,
	|	ВнутреннееПотреблениеТоваров.Номер КАК Номер,
	|	ВнутреннееПотреблениеТоваров.Склад КАК Склад,
	|	ВнутреннееПотреблениеТоваров.Склад.Наименование КАК СкладНаименование,
	|	ВнутреннееПотреблениеТоваров.Подразделение КАК Подразделение,
	|	ВнутреннееПотреблениеТоваров.Подразделение.Наименование КАК ПодразделениеНаименование,
	|	ВнутреннееПотреблениеТоваров.Товары.(Номенклатура, Номенклатура.Наименование, Количество,СтатьяРасходов) КАК Товары
	|ИЗ
	|	Документ.ВнутреннееПотреблениеТоваров КАК ВнутреннееПотреблениеТоваров
	|ГДЕ
	|	ВнутреннееПотреблениеТоваров.ХозяйственнаяОперация = ЗНАЧЕНИЕ(Перечисление.ХозяйственныеОперации.ПринятиеКУчетуОС)
	|{ГДЕ
	|	Ссылка.Дата КАК Дата
	|}
	|УПОРЯДОЧИТЬ ПО 
	|	Номер ВОЗР
	|");
	
	Если Параметры <> Неопределено
		И Параметры.Свойство("Период") Тогда 
		ЭлементОтбора = Построитель.Отбор.Добавить("Дата");
		ЭлементОтбора.Использование = Истина;
		ЭлементОтбора.ВидСравнения = ВидСравнения.ИнтервалВключаяГраницы;
		ЭлементОтбора.ЗначениеС = Параметры.Период.ДатаНачала;
		ЭлементОтбора.ЗначениеПо = Параметры.Период.ДатаОкончания;
	КонецЕсли;
	
	Запрос = Построитель.ПолучитьЗапрос();
	
	Таблица = Запрос.Выполнить().Выгрузить();
	Таблица.Колонки.Добавить("УникальныйИдентификатор", Новый ОписаниеТипов("УникальныйИдентификатор"));
	Таблица.Колонки.Добавить("УникальныйИдентификаторСклад", Новый ОписаниеТипов("УникальныйИдентификатор"));
	Таблица.Колонки.Добавить("УникальныйИдентификаторПодразделение", Новый ОписаниеТипов("УникальныйИдентификатор"));
	Таблица.Колонки.Добавить("УникальныйИдентификаторНоменклатур", Новый ОписаниеТипов("Строка"));
	Таблица.Колонки.Добавить("Состав", Новый ОписаниеТипов("Строка"));
	
	Для Каждого Строка Из Таблица Цикл
		
		Строка.Товары.Свернуть("Номенклатура,НоменклатураНаименование,СтатьяРасходов", "Количество");
		Строка.Товары.Сортировать("Номенклатура Возр");
		
		Строка.УникальныйИдентификатор = Строка.Ссылка.УникальныйИдентификатор();
		Строка.УникальныйИдентификаторСклад = Строка.Склад.УникальныйИдентификатор();
		Строка.УникальныйИдентификаторПодразделение = Строка.Подразделение.УникальныйИдентификатор();
		
		Строка.УникальныйИдентификаторНоменклатур = ПолучитьСтроковыйИдентификаторТЧДляСравнения(Строка.Товары, "Номенклатура,Количество,СтатьяРасходов");
		Строка.Состав = ПолучитьПредставлениеТЧ(Строка.Товары, "НоменклатураНаименование,Количество,СтатьяРасходов");
		
	КонецЦикла;
	
	
	Если Не ВключитьСсылочныеКолонки Тогда
		
		Таблица.Колонки.Удалить("Ссылка");
		
	КонецЕсли;
	
	Таблица.Колонки.Удалить("Товары");
	Таблица.Колонки.Удалить("Склад");
	Таблица.Колонки.Удалить("Подразделение");
	
	Возврат Таблица;
	
КонецФункции


Функция ПолучитьСтроковыйИдентификаторТЧДляСравнения(ТабличнаяЧасть, ПоляКСравнению)
	
	МассивПолейКСравнению = Новый Массив;
	
	СтруктураПолейКСравнению= Новый Структура(ПоляКСравнению);
	Для Каждого ЭлементСтруктуры Из СтруктураПолейКСравнению Цикл 
		МассивПолейКСравнению.Добавить(ЭлементСтруктуры.Ключ);
	КонецЦикла;
	
	ИдентификаторыСтрок = Новый СписокЗначений;
	
	Для Каждого СтрокаТЧ Из ТабличнаяЧасть Цикл
		
		СтрокаСостава = "";
		
		Для Каждого Поле Из МассивПолейКСравнению Цикл
			
			Если ТипЗнч(СтрокаТЧ[Поле]) = Тип("Строка") Тогда
				СтрокаСостава = СтрокаСостава + СтрокаТЧ[Поле] + " ";
			ИначеЕсли ТипЗнч(СтрокаТЧ[Поле]) = Тип("Число") Тогда
				СтрокаСостава = СтрокаСостава + "(" + Формат(СтрокаТЧ[Поле], "ЧН=") + ") ";
			ИначеЕсли ТипЗнч(СтрокаТЧ[Поле]) = Тип("Булево") Тогда
				СтрокаСостава = СтрокаСостава + Строка(СтрокаТЧ[Поле]) + " ";
			ИначеЕсли ЭтоОбъектСсылочногоТипа(СтрокаТЧ[Поле]) Тогда
				СтрокаСостава = СтрокаСостава + Строка(СтрокаТЧ[Поле].УникальныйИдентификатор()) + " ";
			КонецЕсли;
			
		КонецЦикла;
		
		СтрокаСостава = Лев(СтрокаСостава, СтрДлина(СтрокаСостава)-1);
		ИдентификаторыСтрок.Добавить(СтрокаСостава);
		
	КонецЦикла;
	
	ИдентификаторыСтрок.СортироватьПоЗначению(НаправлениеСортировки.Возр);
	
	УникальныйИдентификатор = "";
		
		Для Каждого Идентификатор Из ИдентификаторыСтрок Цикл
			УникальныйИдентификатор = УникальныйИдентификатор + Идентификатор + ",";
		КонецЦикла;
		
		УникальныйИдентификатор = Лев(УникальныйИдентификатор, СтрДлина(УникальныйИдентификатор)-1);
		
		Возврат УникальныйИдентификатор;
	
КонецФункции

Функция ЭтоОбъектСсылочногоТипа(ОбъектДанных)
	
	Попытка
		ОбъектМетаданных = ОбъектДанных.Метаданные();
	Исключение
		Возврат Ложь;
	КонецПопытки;
	
	ИмяБазовогоТипа = "";
	ИмяОсновногоТипа = "";
	
	ИмяОбъектаМетаданных = ОбъектМетаданных.ПолноеИмя();
	Позиция = СтрНайти(ИмяОбъектаМетаданных, ".");
	Если Позиция > 0 Тогда 
		ИмяБазовогоТипа = Лев(ИмяОбъектаМетаданных, Позиция - 1);
		ИмяОсновногоТипа = Сред(ИмяОбъектаМетаданных,Позиция + 1);
		Возврат ИмяБазовогоТипа = "Справочник"
		Или ИмяБазовогоТипа = "Документ"
		Или ИмяБазовогоТипа = "БизнесПроцесс"
		Или ИмяБазовогоТипа = "Задача"
		Или ИмяБазовогоТипа = "ПланСчетов"
		Или ИмяБазовогоТипа = "ПланОбмена"
		Или ИмяБазовогоТипа = "ПланВидовХарактеристик"
		Или ИмяБазовогоТипа = "ПланВидовРасчета";
	Иначе
		Возврат Ложь;
	КонецЕсли;
	
КонецФункции


Функция ПолучитьИдентификаторыКолонкиТЧ(НаименованиеКолонки, ТабличнаяЧасть)
	
	СтроковыеИдентификаторы = Новый СписокЗначений;
		
		Для Каждого СтрокаТЧ Из ТабличнаяЧасть Цикл
			СтроковыеИдентификаторы.Добавить(Строка(СтрокаТЧ[НаименованиеКолонки].УникальныйИдентификатор()));
		КонецЦикла;
		
		СтроковыеИдентификаторы.СортироватьПоЗначению(НаправлениеСортировки.Возр);
		
		УникальныйИдентификатор = "";
		
		Для Каждого Идентификатор Из СтроковыеИдентификаторы Цикл
			УникальныйИдентификатор = УникальныйИдентификатор + Идентификатор + ",";
		КонецЦикла;
		
		УникальныйИдентификатор = Лев(УникальныйИдентификатор, СтрДлина(УникальныйИдентификатор)-1);
		
		Возврат УникальныйИдентификатор;
		
	КонецФункции

Функция ПолучитьПредставлениеТЧ(ТабличнаяЧасть, ПоляКПредставлению)
	
	МассивПолейКПредставлению = Новый Массив;
	
	СтруктураПолейКПредставлению= Новый Структура(ПоляКПредставлению);
	Для Каждого ЭлементСтруктуры Из СтруктураПолейКПредставлению Цикл 
		МассивПолейКПредставлению.Добавить(ЭлементСтруктуры.Ключ);
	КонецЦикла;
	
	Состав = Новый Массив;
	
	Для Каждого СтрокаТЧ Из ТабличнаяЧасть Цикл
		
		СтрокаСостава = "";
		
		Для Каждого Поле Из МассивПолейКПредставлению Цикл
			
			Если ТипЗнч(СтрокаТЧ[Поле]) = Тип("Строка") Тогда
				СтрокаСостава = СтрокаСостава + СтрокаТЧ[Поле] + Символы.Таб;
			ИначеЕсли ТипЗнч(СтрокаТЧ[Поле]) = Тип("Число") Тогда
				СтрокаСостава = СтрокаСостава + "(" + Формат(СтрокаТЧ[Поле], "ЧН=") + ")" + Символы.Таб;
			ИначеЕсли ТипЗнч(СтрокаТЧ[Поле]) = Тип("Булево") Тогда
				СтрокаСостава = СтрокаСостава + Строка(СтрокаТЧ[Поле]) + Символы.Таб;
			Иначе
				Попытка
					СтрокаСостава = СтрокаСостава + Строка(СтрокаТЧ[Поле]) + Символы.Таб;
				Исключение
					ВызватьИсключение("Неверный тип поля");
				КонецПопытки;
			КонецЕсли;
			
		КонецЦикла;
		
		СтрокаСостава = Лев(СтрокаСостава, СтрДлина(СтрокаСостава)-1);
		
		Состав.Добавить(СтрокаСостава);
			
			//Состав.Добавить(СтроковыеФункцииКлиентСервер.ПодставитьПараметрыВСтроку("%1 (%2)"
			//, СтрокаТЧ.НоменклатураНаименование
			//, Формат(СтрокаТЧ.Количество, "ЧН=")
			//));
			
	КонецЦикла;
	
	ВыходнаяСтрока = СтрСоединить(Состав, "," + Символы.ПС);
	
	Возврат ВыходнаяСтрока;
	
КонецФункции

Функция ПреобразоватьПеречислениеВСтроку(Значение)
	
	Если Значение = Перечисления.ЮрФизЛицо.ЮрЛицо Тогда
		Возврат "Юридическое лицо";
	ИначеЕсли Значение = Перечисления.ЮрФизЛицо.ЮрЛицоНеРезидент Тогда
		Возврат "Юридическое лицо";
	ИначеЕсли Значение = Перечисления.ЮрФизЛицо.ФизЛицо Тогда
		Возврат "Физическое лицо";
	ИначеЕсли Значение = Перечисления.ЮрФизЛицо.ИндивидуальныйПредприниматель Тогда
		Возврат "Физическое лицо";
	ИначеЕсли Значение = Перечисления.СтавкиНДС.НДС18 Тогда
		Возврат "НДС18";
	ИначеЕсли Значение = Перечисления.СтавкиНДС.НДС18_118 Тогда
		Возврат "НДС18_118";
	ИначеЕсли Значение = Перечисления.СтавкиНДС.НДС10 Тогда
		Возврат "НДС10";
	ИначеЕсли Значение = Перечисления.СтавкиНДС.НДС10_110 Тогда
		Возврат "НДС10_110";
	ИначеЕсли Значение = Перечисления.СтавкиНДС.НДС0 Тогда
		Возврат "НДС0";
	ИначеЕсли Значение = Перечисления.СтавкиНДС.БезНДС Тогда
		Возврат "БезНДС";
	ИначеЕсли Значение = Перечисления.СтавкиНДС.НДС20 Тогда
		Возврат "НДС20";
	ИначеЕсли Значение = Перечисления.СтавкиНДС.НДС20_120 Тогда
		Возврат "НДС20_120";
	КонецЕсли;
	
КонецФункции


Функция ИзменитьТипКолонки(Таблица, ИмяКолонки, ТипПриведения)
	
	Если Таблица.Колонки.Найти(ИмяКолонки) = Неопределено Тогда
		Возврат Неопределено;
	КонецЕсли;
	
	Если ТипПриведения = "Строка" Тогда
		Тип = Новый ОписаниеТипов("Строка, null",,,,Новый КвалификаторыСтроки(1000, ДопустимаяДлина.Переменная));
	ИначеЕсли ТипПриведения = "Число" Тогда
		Тип = Новый ОписаниеТипов("Число, null",,,,Новый КвалификаторыЧисла(20, 3, ДопустимыйЗнак.Любой));
	КонецЕсли;
	
	Колонка = Таблица.ВыгрузитьКолонку(ИмяКолонки);
	
	Таблица.Колонки.Удалить(ИмяКолонки);
	
	НоваяКолонка = Таблица.Колонки.Добавить(ИмяКолонки, Тип);
	
	Таблица.ЗагрузитьКолонку(Колонка, ИмяКолонки);
	
КонецФункции

Процедура ПреобразоватьСумму(Таблица)
	
	ИзменитьТипКолонки(Таблица, "Сумма", "Число");
	ИзменитьТипКолонки(Таблица, "СуммаДокумента", "Число");
	ИзменитьТипКолонки(Таблица, "Стоимость", "Число");
		
КонецПроцедуры

#КонецОбласти
